com.smartgwt.client.widgets.chart

## Class FacetChart

- java.lang.Object
- - com.google.gwt.user.client.ui.UIObject
  - - com.google.gwt.user.client.ui.Widget
    - - com.smartgwt.client.widgets.BaseWidget
      - - com.smartgwt.client.widgets.Canvas
        - - com.smartgwt.client.widgets.drawing.DrawPane
          - - com.smartgwt.client.widgets.chart.FacetChart

- All Implemented Interfaces:
    com.google.gwt.event.logical.shared.HasAttachHandlers, com.google.gwt.event.shared.HasHandlers, com.google.gwt.user.client.EventListener, com.google.gwt.user.client.ui.HasVisibility, com.google.gwt.user.client.ui.IsWidget, LogicalStructure, HasChartBackgroundDrawnHandlers, HasChartDrawnHandlers, HasZoomChangedHandlers, HasClickHandlers, HasDoubleClickHandlers, HasDragMoveHandlers, HasDragRepositionMoveHandlers, HasDragRepositionStartHandlers, HasDragRepositionStopHandlers, HasDragResizeMoveHandlers, HasDragResizeStartHandlers, HasDragResizeStopHandlers, HasDragStartHandlers, HasDragStopHandlers, HasDropHandlers, HasDropMoveHandlers, HasDropOutHandlers, HasDropOverHandlers, HasFocusChangedHandlers, HasHoverHandlers, HasHoverHiddenHandlers, HasKeyDownHandlers, HasKeyPressHandlers, HasMouseDownHandlers, HasMouseMoveHandlers, HasMouseOutHandlers, HasMouseOverHandlers, HasMouseStillDownHandlers, HasMouseUpHandlers, HasMouseWheelHandlers, HasMovedHandlers, HasParentMovedHandlers, HasResizedHandlers, HasRightMouseDownHandlers, HasScrolledHandlers, HasShowContextMenuHandlers, HasVisibilityChangedHandlers

      public class FacetChart
      extends DrawPane
      implements HasChartBackgroundDrawnHandlers, HasChartDrawnHandlers, HasZoomChangedHandlers

  HTML5-based charting engine, implementing all chartTypes of the Chart interface.

  Can be used directly, or specified as `chartConstructor` or `chartConstructor`.

  NOTE: you must load the Drawing and Charts `Optional Modules` before you can use FacetChart.

  To create a FacetChart, set `facets` to an Array of Facet objects describing the chart dimensions and `valueProperty` to value field name. For example:

        // Creating data
        Record sprRec = new Record();
        sprRec.setAttribute("season", "Spring");
        sprRec.setAttribute("temp", "79");
        Record sumRec = new Record();
        sumRec.setAttribute("season", "Summer");
        sumRec.setAttribute("temp", "102");
        Record autRec = new Record();
        autRec.setAttribute("season", "Autumn");
        autRec.setAttribute("temp", "81");
        Record winRec = new Record();
        winRec.setAttribute("season", "Winter");
        winRec.setAttribute("temp", "59");

        // Creating chart
        FacetChart chart = new FacetChart();
        chart.setFacets(new Facet("season", "Season"));
        chart.setValueProperty("temp");
        chart.setData(new Record[]{sprRec, sumRec, autRec, winRec});
        chart.setTitle("Average temperature in Las Vegas");

  The following SDK examples demonstrate charts with a single facet:

  - Log Scaling example,
  - Interactive Data Points example, and
  - Adding Element example.
  See the following SDK examples for examples of charts with multiple facets:
  - Simple Chart example,
  - Multi-Series Chart example, and
  - Dynamic Data example.

  ### the Inlined Facet

  Having an "inlined facet" is another method to provide data to the chart. In this case each CellRecord contains multiple data values; one facet definition is considered "inlined", meaning that the facetValueIds from this facet appear as properties in each Record, and each such property holds one data value. In this case the singular `valueProperty` is ignored. For example:

        // Creating data
        CellRecord lvRec = new CellRecord();
        lvRec.setAttribute("spring", "79");
        lvRec.setAttribute("summer", "102");
        lvRec.setAttribute("autumn", "81");
        lvRec.setAttribute("winter", "59");

        // Creating inlined facet
        Facet inlinedFacet = new Facet();
        inlinedFacet.setInlinedValues(true);
        inlinedFacet.setValues(
                new FacetValue("spring", "Spring"),
                new FacetValue("summer", "Summer"),
                new FacetValue("autumn", "Autumn"),
                new FacetValue("winter", "Winter"));

        // Creating chart
        FacetChart chart = new FacetChart();
        chart.setFacets(inlinedFacet);
        chart.setData(new Record[]{lvRec});
        chart.setTitle("Average temperature in Las Vegas");

  Example with two facets:

        // Creating data
        CellRecord lvRec = new CellRecord();
        lvRec.setAttribute("city", "Las Vegas");
        lvRec.setAttribute("spring", "79");
        lvRec.setAttribute("summer", "102");
        lvRec.setAttribute("autumn", "81");
        lvRec.setAttribute("winter", "59");
        CellRecord nyRec = new CellRecord();
        nyRec.setAttribute("city", "New York");
        nyRec.setAttribute("spring", "60");
        nyRec.setAttribute("summer", "83");
        nyRec.setAttribute("autumn", "66");
        nyRec.setAttribute("winter", "40");

        // Creating inlined facet
        Facet inlinedFacet = new Facet();
        inlinedFacet.setInlinedValues(true);
        inlinedFacet.setValues(
                new FacetValue("spring", "Spring"),
                new FacetValue("summer", "Summer"),
                new FacetValue("autumn", "Autumn"),
                new FacetValue("winter", "Winter"));

        // Creating chart
        FacetChart chart = new FacetChart();
        chart.setFacets(inlinedFacet, new Facet("city", "City"));
        chart.setData(new Record[]{lvRec, nyRec});
        chart.setStacked(false);
        chart.setTitle("Average temperatures");

  ### Dual axis or multi-axis charts

  FacetChart supports drawing multiple vertical axes. This is commonly used to show values with different units (for example: sales in dollars, total units shipped) and/or very different ranges (for example: gross revenue, profit) on the same chart. Each set of values, referred to as a "metric", gets its own axis and gradation marks.

  To use multiple axes, you add an additional facet called the "metric facet" that specifies each axis to be plotted as a facetValueId. The metric facet is an inlined facet, so as with inlined facets in general, each CellRecord has a value for each facetValueId of the metric facet. You then set `extraAxisMetrics` to the list of metrics that should be plotted as additional axes.

  For example, if you were plotting revenue and profit for each month of the year, you would have one facet named "metric" with facetValueIds "revenue" and "profit" and a second facet "month". Each CellRecord would have the revenue and profit for one month, stored under the properties "revenue" and "profit". Setting `extraAxisMetrics` to ["profit"] would cause plofit to be plotted as the second axis. See the Dual Axis SDK sample for an example.

  You can have multiple extra axes and the additional axes and gradation tics will be drawn at increasing distances from the chart. By default, the first metric is drawn as a column chart and subsequent metrics are drawn as lines; you can override this via `extraAxisSettings`. See the 3+ Axes SDK sample for an example of multiple extra axes.

  Multi-axis, multi-facet charts are also allowed. Extending the previous example, you might add a new facet "company", for a total of 3 facets. Each CellRecord would have "revenue" and "profit" for one combination of "company" and "month". The default appearance in this case would show revenue as clustered columns (one cluster per month, one column per company) and would show profit as multiple lines (one per company). See the Multi-Series SDK sample for an example of a multi-axis, multi-facet chart.

  ### Scatter Charts

  Scatter charts differ from other chart types in that both axes represent continuous numeric data rather than a discrete set of facet values (like months of the year). For this reason Scatter charts use the same concept of a "metric" facet as is used by Dual-Axis charts, where the metric facet is expected to have exactly two metrics: the `xAxisMetric` and `yAxisMetric`.

  Unlike all other chart types, a scatter plot may be specified with only the metric facet. However one additional facet can be defined, which allows multiple sets of x,y points to be drawn in different colors, analogous to the different colors of a multi-series line chart.

  See the Scatter Plot SDK example.

  ### Notes on printing

  FacetCharts support printing on all supported desktop browsers. With Pro or better, charts can also be exported to PDF via `RPCManager.exportContent`.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.google.gwt.user.client.ui.UIObject

      `com.google.gwt.user.client.ui.UIObject.DebugIdImpl, com.google.gwt.user.client.ui.UIObject.DebugIdImplEnabled`

  - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.widgets.BaseWidget

      `config, configOnly, id, isElementSet, nativeObject, scClassName`

    - ### Fields inherited from class com.google.gwt.user.client.ui.UIObject

      `DEBUG_ID_PREFIX`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `FacetChart()`
    `FacetChart(com.google.gwt.core.client.JavaScriptObject jsObj)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `com.google.gwt.event.shared.HandlerRegistration` | `addChartBackgroundDrawnHandler(ChartBackgroundDrawnHandler handler)` Add a chartBackgroundDrawn handler.
    `com.google.gwt.event.shared.HandlerRegistration` | `addChartDrawnHandler(ChartDrawnHandler handler)` Add a chartDrawn handler.
    `com.google.gwt.event.shared.HandlerRegistration` | `addZoomChangedHandler(ZoomChangedHandler handler)` Add a zoomChanged handler.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, Canvas defaults)` Changes the defaults for Canvas AutoChildren named `autoChildName`.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, FormItem defaults)` Changes the defaults for FormItem AutoChildren named `autoChildName`.
    `protected com.google.gwt.core.client.JavaScriptObject` | `create()`
    `java.lang.Boolean` | `getAutoRotateLabels()` Deprecated. As of Smart GWT 9.0 this property is replaced by the property `rotateLabels`. Setting rotateLabels to "auto" is equivalent to setting autoRotateLabels to `true`. Setting rotateLabels to "never" is equivalent to setting autoRotateLabels to `false`.
    `DrawRect` | `getBackgroundBandProperties()` Properties for background band
    `java.lang.Boolean` | `getBandedBackground()` Whether to show alternating color bands in the background of chart.
    `java.lang.Boolean` | `getBandedStandardDeviations()` Whether to show color bands between the `standard deviation` lines.
    `int` | `getBarMargin()` Distance between bars.
    `DrawRect` | `getBarProperties()` Properties for bar
    `java.lang.Boolean` | `getCanMoveAxes()` Whether the positions of value axes can be changed.
    `java.lang.Boolean` | `getCanZoom()` Enables "zooming" on the X axis, specifically, only a portion of the overall dataset is shown in the main chart, and a `second smaller chart` appears with slider controls allowing a range to be selected for display in the main chart.
    `Point` | `getChartCenter()` Returns the centerpoint for radar charts and pie charts.
    `float` | `getChartHeight(boolean recalc)` Get the height the central chart area, where data elements appear.
    `double` | `getChartHeightAsDouble(boolean recalc)` Get the height the central chart area, where data elements appear.
    `float` | `getChartLeft()` Get the left margin of the central chart area, where data elements appear.
    `double` | `getChartLeftAsDouble()` Get the left margin of the central chart area, where data elements appear.
    `float` | `getChartRadius()` Returns the radius for radar charts and pie charts.
    `double` | `getChartRadiusAsDouble()` Returns the radius for radar charts and pie charts.
    `int` | `getChartRectMargin()` Margin around the main chart rect: between title and chart, between chart and axis labels, and chart rect and right edge of chart.
    `DrawRect` | `getChartRectProperties()` Properties for chart rect
    `float` | `getChartTop()` Get the top coordinate of the central chart area, where data elements appear.
    `double` | `getChartTopAsDouble()` Get the top coordinate of the central chart area, where data elements appear.
    `ChartType` | `getChartType()` See `ChartType` for a list of known types - Column, Bar, Line, Pie, Doughnut, Area, and Radar charts are supported.
    `float` | `getChartWidth(boolean recalc)` Get the width of the central chart area, where data elements appear.
    `double` | `getChartWidthAsDouble(boolean recalc)` Get the width of the central chart area, where data elements appear.
    `float` | `getClusterMarginRatio()` For clustered charts, ratio between margins between individual bars and margins between clusters.
    `java.lang.Float` | `getColorMutePercent()` Should be set to a number between -100 and 100.
    `RecordList` | `getDataAsRecordList()`
    `DrawLabel` | `getDataAxisLabelProperties()` Properties for labels of data axis.
    `java.lang.String` | `getDataColor(int index)` Get a color from the `dataColors` Array
    `java.lang.String[]` | `getDataColors()` An array of colors to use for a series of visual elements representing data (eg columns, bars, pie slices), any of which may be adjacent to any other.
    `DrawLabel` | `getDataLabelProperties()` Properties for data label
    `DrawLine` | `getDataLineProperties()` Properties for lines that show data (as opposed to gradations or borders around the data area).
    `DataLineType` | `getDataLineType()` How to draw lines between adjacent data points in Line and Scatter charts.
    `int` | `getDataMargin()` For rectangular charts (bar, column, line), margin around the inside of the main chart area, so that data elements are not flush to edge.
    `DrawItem` | `getDataOutlineProperties()` Properties for lines that outline a data shape (in filled charts such as area or radar charts).
    `DrawItem` | `getDataPointProperties()` Common properties to apply for all data points (see `showDataPoints`).
    `int` | `getDataPointSize()` Size in pixels for data points drawn for line, area, radar and other chart types.
    `DrawPath` | `getDataShapeProperties()` Properties for data shapes (filled areas in area or radar charts).
    `int` | `getDecimalPrecision()` Default precision used when formatting float numbers for axis labels
    `java.lang.Boolean` | `getDiscontinuousLines()` Whether to treat non-numeric values in the dataset as indicating a break in the data line.
    `DrawOval` | `getDoughnutHoleProperties()` Properties for doughnut hole
    `float` | `getDoughnutRatio()` If showing a doughnut hole (see `showDoughnut`), ratio of the size of the doughnut hole to the size of the overall pie chart, as a number between 0 to 1.
    `DrawnValue` | `getDrawnValue(FacetValueMap facetValues)` Returns rendering information for the data value specified by the passed facet values.
    `float` | `getErrorBarColorMutePercent()` This property helps specify the color of the error bars and its value must be a number between -100 and 100.
    `int` | `getErrorBarWidth()` Width of the horizontal line of the "T"-shape portion of the error bar).
    `DrawLine` | `getErrorLineProperties()` Properties of the lines used to draw error bars (short, horizontal lines at the low and high metric values, and a vertical connecting line).
    `DrawItem` | `getExpectedValueLineProperties()` Properties for the `line drawn at the mean value`.
    `java.lang.String[]` | `getExtraAxisMetrics()` Defines the set of metrics that will be plotted as additional vertical axes.
    `MetricSettings[]` | `getExtraAxisSettings()` For charts will multiple vertical axes, optionally provides settings for how each `extra axis metric` is plotted.
    `Facet` | `getFacet(java.lang.String facetId)` Get a facet definition by facetId.
    `Facet[]` | `getFacets()` Return the chart's facets.
    `FacetValue` | `getFacetValue(java.lang.String facetId, java.lang.String facetValueId)` Get facet value definition by facetId and facetValueId.
    `java.lang.Boolean` | `getFilled()` Whether shapes are filled, for example, whether a multi-series line chart appears as a stack of filled regions as opposed to just multiple lines.
    `DrawLabel` | `getGradationLabelProperties()` Properties for gradation labels
    `DrawLine` | `getGradationLineProperties()` Properties for gradation lines
    `float[]` | `getGradations()` Return an array of the gradation values used in the current chart.
    `int` | `getGradationTickMarkLength()` Length of the tick marks used to denote the gradations of any `extra value axes`.
    `DrawLine` | `getGradationZeroLineProperties()` Properties for the gradation line drawn for zero (slightly thicker by default).
    `java.lang.String` | `getHighErrorMetric()` See `lowErrorMetric`.
    `DrawLabel` | `getHoverLabelProperties()` Properties for text in a floating label that represents the data value shown whenever the mouse moves withing the main chart area when `showValueOnHover` is enabled.
    `DrawRect` | `getHoverRectProperties()` Properties for rectangle that drawed behind of a floating hover label that represents the data value.
    `LabelCollapseMode` | `getLabelCollapseMode()` What to do when there are too many data points to be able to show labels for every data point at the current chart size - see `LabelCollapseMode`.
    `int` | `getLegendItemPadding()` Padding between each swatch and label pair.
    `DrawLabel` | `getLegendLabelProperties()` Properties for labels shown next to legend color swatches.
    `int` | `getLegendMargin()` Space between the legend and the chart rect or axis labels (whatever the legend is adjacent to.
    `int` | `getLegendPadding()` Padding around the legend as a whole.
    `DrawRect` | `getLegendRectProperties()` Properties for rectangle around the legend as a whole.
    `DrawRect` | `getLegendSwatchProperties()` Properties for the swatches of color shown in the legend.
    `int` | `getLegendSwatchSize()` Size of individual color swatches in legend.
    `int` | `getLegendTextPadding()` Padding between color swatch and its label.
    `int` | `getLogBase()` When `useLogGradations`, base value for logarithmic gradation lines.
    `float[]` | `getLogGradations()` When `useLogGradations` is set, gradation lines to show in between powers, expressed as a series of integer or float values between 1 and `logBase`.
    `com.smartgwt.logicalstructure.core.LogicalStructureObject` | `getLogicalStructure()`
    `java.lang.Boolean` | `getLogScale()` Whether to use logarithmic scaling for values.
    `java.lang.String` | `getLowErrorMetric()` `lowErrorMetric` and `highErrorMetric` can be used to cause error bars to appear above and below the main data point.
    `float` | `getMax(FacetValueMap criteria)` Calculate the maximum of the data from a single metric.
    `float` | `getMax(java.lang.String criteria)` Calculate the maximum of the data from a single metric.
    `int` | `getMaxBarThickness()` Bars will not be drawn over this thickness, instead, margins will be increased.
    `float` | `getMean(FacetValueMap criteria)` Calculate the mean, or expected value, of the data over a single metric.
    `float` | `getMean(java.lang.String criteria)` Calculate the mean, or expected value, of the data over a single metric.
    `float` | `getMedian(FacetValueMap criteria)` Calculate the median of the data over a single metric.
    `float` | `getMedian(java.lang.String criteria)` Calculate the median of the data over a single metric.
    `float` | `getMin(FacetValueMap criteria)` Calculate the minimum of the data from a single metric.
    `float` | `getMin(java.lang.String criteria)` Calculate the minimum of the data from a single metric.
    `int` | `getMinBarThickness()` If bars would be smaller than this size, margins are reduced until bars overlap.
    `java.lang.Integer` | `getMinLabelGap()` Minimum gap between labels on the X axis before some labels are omitted or larger time granularity is shown (eg show days instead of hours) based on the `labelCollapseMode`.
    `DrawnValue` | `getNearestDrawnValue()` Returns rendering information for the data value that is shown nearest to the passed coordinates, as a `DrawnValue` object.
    `DrawnValue` | `getNearestDrawnValue(java.lang.Integer x)`
    `DrawnValue` | `getNearestDrawnValue(java.lang.Integer x, java.lang.Integer y)`
    `DrawnValue` | `getNearestDrawnValue(java.lang.Integer x, java.lang.Integer y, java.lang.String metric)` Returns rendering information for the data value that is shown nearest to the passed coordinates, as a `DrawnValue` object.
    `DrawnValue[]` | `getNearestDrawnValues()` Returns an array of `DrawnValue` objects containing rendering information for the data values having each metric that are shown nearest to the passed coordinates.
    `DrawnValue[]` | `getNearestDrawnValues(java.lang.Integer x)`
    `DrawnValue[]` | `getNearestDrawnValues(java.lang.Integer x, java.lang.Integer y)` Returns an array of `DrawnValue` objects containing rendering information for the data values having each metric that are shown nearest to the passed coordinates.
    `int` | `getNumDataPoints()` Count the number of data points.
    `int` | `getNumDataPoints(FacetValueMap criteria)` Count the number of data points.
    `static FacetChart` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `float` | `getPercentile(FacetValueMap criteria, float percentile)` Calculate a percentile of the data over a single metric.
    `float` | `getPercentile(java.lang.String criteria, float percentile)` Calculate a percentile of the data over a single metric.
    `DrawOval` | `getPieBorderProperties()` Properties for the border around a pie chart.
    `int` | `getPieLabelAngleStart()` Angle where first label is placed in a Pie chart in stacked mode, in degrees.
    `int` | `getPieLabelLineExtent()` How far label lines stick out of the pie radius in a Pie chart in stacked mode.
    `DrawLine` | `getPieLabelLineProperties()` Properties for pie label line
    `DrawOval` | `getPieRingBorderProperties()` Properties for pie ring border
    `DrawSector` | `getPieSliceProperties()` Properties for pie slices
    `PointShape[]` | `getPointShapes()` For charts where `showDataPoints` is enabled, this property specifies an array of geometric shapes to draw for the data points of each series.
    `void` | `getPolynomialRegressionFunction()` For scatter plots only, get a Function from the specified independent variable X to the specified dependent variable Y that defines the polynomial that best fits the data.
    `void` | `getPolynomialRegressionFunction(java.lang.Integer degree)`
    `void` | `getPolynomialRegressionFunction(java.lang.Integer degree, java.lang.String xMetric)`
    `void` | `getPolynomialRegressionFunction(java.lang.Integer degree, java.lang.String xMetric, java.lang.String yMetric)` For scatter plots only, get a Function from the specified independent variable X to the specified dependent variable Y that defines the polynomial that best fits the data.
    `java.lang.String` | `getPrintHTML(PrintProperties printProperties, PrintHTMLCallback callback)` Retrieves printable HTML for this component and all printable subcomponents.
    `java.lang.String` | `getProbabilityMetric()` The "id" of the metric facet value that assigns a probability to each combination of facets and their values.
    `DrawOval` | `getRadarBackgroundProperties()` Properties for radar background
    `int` | `getRadialLabelOffset()` Distance in pixels that radial labels are offset from the outside of the circle.
    `float` | `getRange(FacetValueMap criteria)` Calculate the range of the data from a single metric.
    `float` | `getRange(java.lang.String criteria)` Calculate the range of the data from a single metric.
    `Record[]` | `getRecords()`
    `DrawLine` | `getRegressionLineProperties()` Properties for the `regression line`.
    `RegressionLineType` | `getRegressionLineType()` Regression algorithm used for the `regression line`.
    `int` | `getRegressionPolynomialDegree()` For scatter plots only, specify the degree of polynomial to use for any polynomial regression that is calculated.
    `LabelRotationMode` | `getRotateLabels()` This property controls whether to rotate the labels on the X-axis.
    `DrawOval` | `getShadowProperties()` Properties for shadows.
    `java.lang.Boolean` | `getShowChartRect()` Whether to show a rectangular shape around the area of the chart where data is plotted.
    `java.lang.Boolean` | `getShowDataAxisLabel()` Whether to show a label for the data axis as a whole (the data axis is where labels for each data point appear).
    `java.lang.Boolean` | `getShowDataPoints()` For line charts, whether to show data points for each individual data value.
    `boolean` | `getShowDataValues()` Should data values be shown as text labels near the shape representing the value, for example, above columns of a column chart, or adjacent to points in a line chart?
    `java.lang.Boolean` | `getShowDoughnut()` Whether to show a "doughnut hole" in the middle of pie charts.
    `java.lang.Boolean` | `getShowExpectedValueLine()` Display a line at the `mean value`.
    `java.lang.Boolean` | `getShowGradationsOverData()` If set, gradation lines are drawn on top of data rather than underneath.
    `java.lang.Boolean` | `getShowInlineLabels()` Causes labels for the X axis to be shown above the axis and to the right of the gradation line they label, making for a vertically more compact chart at the risk of gradation labels being partially obscured by data values.
    `java.lang.Boolean` | `getShowLegend()` The legend is automatically shown for charts that need it (generally, multi-series charts) but can be forced off by setting showLegend to false.
    `java.lang.Boolean` | `getShowRadarGradationLabels()` Whether to show gradation labels in radar charts.
    `java.lang.Boolean` | `getShowRegressionLine()` For scatter plots only, whether to display a regression curve that best fits the data of the two metric facet values.
    `java.lang.Boolean` | `getShowScatterLines()` Whether to draw lines between adjacent data points in "Scatter" plots.
    `java.lang.Boolean` | `getShowShadows()` Whether to automatically show shadows for various charts.
    `java.lang.Boolean` | `getShowStandardDeviationLines()` Display multiple `standard deviations` away from the mean as lines.
    `java.lang.Boolean` | `getShowStatisticsOverData()` If set, the `mean line`, `standard deviation lines`, `standard deviation bands`, and `regression curves` are drawn on top of the data rather than underneath.
    `java.lang.Boolean` | `getShowTitle()` Whether to show a title.
    `java.lang.Boolean` | `getShowValueAxisLabel()` Whether to show the `valueTitle` as a label on the value axis.
    `java.lang.Boolean` | `getShowValueOnHover()` Shows the value of the nearest data value in a floating label whenever the mouse moves within the main chart area.
    `void` | `getSimpleLinearRegressionFunction()` For scatter plots only, get a Function from the specified independent variable X to the specified dependent variable Y that defines the line that best fits the data.
    `void` | `getSimpleLinearRegressionFunction(java.lang.String xMetric)`
    `void` | `getSimpleLinearRegressionFunction(java.lang.String xMetric, java.lang.String yMetric)` For scatter plots only, get a Function from the specified independent variable X to the specified dependent variable Y that defines the line that best fits the data.
    `java.lang.Boolean` | `getStacked()` Whether to use stacking for charts where this makes sense (column, area, pie, line and radar charts).
    `DrawItem[]` | `getStandardDeviationBandProperties()` An Array of DrawRect properties to specify the bands between the `standard deviation lines`.
    `DrawItem` | `getStandardDeviationLineProperties()` Properties for the `standard deviation lines`.
    `java.lang.Float[]` | `getStandardDeviations()` When `showStandardDeviationLines` is set, the number of standard deviation lines drawn and their respective standard deviation away from the mean are specified by this property.
    `float` | `getStdDev(FacetValueMap criteria, boolean population)` Calculate the standard deviation of the data from a single metric.
    `float` | `getStdDev(java.lang.String criteria, boolean population)` Calculate the standard deviation of the data from a single metric.
    `java.lang.String` | `getStyleName()` Default styleName for the chart.
    `int` | `getTickMarkToValueAxisMargin()` Margin between the tick marks and the labels of the `extra value axes`.
    `java.lang.String` | `getTitle()` Title for the chart as a whole.
    `DrawLabel` | `getTitleProperties()` Properties for title label.
    `java.lang.Boolean` | `getUseAutoGradients()` Causes the chart to use the colors specified in `dataColors` but specify chart-specific gradients based on the primary data color per chart type.
    `java.lang.Boolean` | `getUseLogGradations()` Whether to use classic logarithmic gradations, where each order of magnitude is shown as a gradation as well as a few intervening lines.
    `java.lang.Boolean` | `getUseMultiplePointShapes()` Whether the chart should use multiple shapes to show data points.
    `java.lang.Boolean` | `getUseSymmetricStandardDeviations()` Whether to display both the positive and negative of the `standard deviations`.
    `DrawLabel` | `getValueAxisLabelProperties()` Properties for labels of value axis.
    `int` | `getValueAxisMargin()` Margin between `multiple value axes`.
    `DrawLine` | `getValueLineProperties()` Properties for a "value line" - a line shows where a particular discrete value is placed, eg, vertical lines connecting points of a line chart to the X axis, or radial lines in a Radar chart.
    `java.lang.String` | `getValueProperty()` Property in each record that holds a data value.
    `java.lang.String` | `getValueTitle()` A label for the data values, such as "Sales in Thousands", typically used as the label for the value axis.
    `float` | `getVariance(FacetValueMap criteria, boolean population)` Calculate the variance of the data from a single metric.
    `float` | `getVariance(java.lang.String criteria, boolean population)` Calculate the variance of the data from a single metric.
    `java.lang.String` | `getXAxisMetric()` For scatter charts only, the "id" of the metric facet value to use for the x-axis.
    `float` | `getXCoord(FacetValueMap criteria)` Returns the X coordination where the passed data value would be drawn.
    `float` | `getXCoord(float value)` Returns the X coordination where the passed data value would be drawn.
    `java.lang.String` | `getYAxisMetric()` For scatter charts only, the "id" of the metric facet value to use for the y-axis.
    `float` | `getYCoord(FacetValueMap criteria)` Returns the Y coordination where the passed data value would be drawn.
    `float` | `getYCoord(float value)` Returns the Y coordination where the passed data value would be drawn.
    `FacetChart` | `getZoomChart()` Mini-chart created to allow zooming when `canZoom` is enabled.
    `FacetChart` | `getZoomChartProperties()` Properties to further configure the `zoomChart`.
    `RangeSlider` | `getZoomChartSlider()` Slider controls shown on the mini-chart which is created when `canZoom` is enabled.
    `java.lang.Object` | `getZoomEndValue()` For a `zoomed chart`, end value of the data range shown in the main chart.
    `java.lang.Boolean` | `getZoomLogScale()` By default when `canZoom` is enabled, the `zoomChart` uses logarithmic scaling so that spikes in the data don't result in a zoomed chart that is mostly a flat line.
    `float` | `getZoomMutePercent()` `colorMutePercent` to use for the `zoomChart`.
    `FacetChart` | `getZoomSelectionChart()` Mini-chart created when `canZoom` is enabled.
    `FacetChart` | `getZoomSelectionChartProperties()` Properties to further configure the `zoomSelectionChart`.
    `java.lang.Boolean` | `getZoomShowSelection()` Whether the selected range should be shown in a different style, which can be configured via `zoomSelectionChartProperties`.
    `ZoomStartPosition` | `getZoomStartPosition()` For a `zoomed chart`, determines what portion of the overall dataset should be initially shown in the main chart.
    `java.lang.Object` | `getZoomStartValue()` For a `zoomed chart`, start value of the data range shown in the main chart.
    `void` | `setAutoRotateLabels(java.lang.Boolean autoRotateLabels)` Deprecated. As of Smart GWT 9.0 this property is replaced by the property `rotateLabels`. Setting rotateLabels to "auto" is equivalent to setting autoRotateLabels to `true`. Setting rotateLabels to "never" is equivalent to setting autoRotateLabels to `false`.
    `void` | `setAxisValueFormatter(ValueFormatter formatter)` Formatter to apply to values displayed in the gradation labels.
    `void` | `setBackgroundBandProperties(DrawRect backgroundBandProperties)` Properties for background band
    `void` | `setBandedBackground(java.lang.Boolean bandedBackground)` Whether to show alternating color bands in the background of chart.
    `void` | `setBandedStandardDeviations(java.lang.Boolean bandedStandardDeviations)` Whether to show color bands between the `standard deviation` lines.
    `void` | `setBarMargin(int barMargin)` Distance between bars.
    `void` | `setBarProperties(DrawRect barProperties)` Properties for bar
    `void` | `setCanMoveAxes(java.lang.Boolean canMoveAxes)` Whether the positions of value axes can be changed.
    `void` | `setCanZoom(java.lang.Boolean canZoom)` Enables "zooming" on the X axis, specifically, only a portion of the overall dataset is shown in the main chart, and a `second smaller chart` appears with slider controls allowing a range to be selected for display in the main chart.
    `void` | `setChartRectMargin(int chartRectMargin)` Margin around the main chart rect: between title and chart, between chart and axis labels, and chart rect and right edge of chart.
    `void` | `setChartRectProperties(DrawRect chartRectProperties)` Properties for chart rect
    `void` | `setChartType(ChartType chartType)` See `ChartType` for a list of known types - Column, Bar, Line, Pie, Doughnut, Area, and Radar charts are supported.
    `void` | `setClusterMarginRatio(float clusterMarginRatio)` For clustered charts, ratio between margins between individual bars and margins between clusters.
    `void` | `setColorMutePercent(java.lang.Float colorMutePercent)` Should be set to a number between -100 and 100.
    `void` | `setData(Record[] records)` Dataset for this chart.
    `void` | `setData(RecordList records)`
    `void` | `setDataAxisLabelProperties(DrawLabel dataAxisLabelProperties)` Properties for labels of data axis.
    `void` | `setDataColors(java.lang.String... dataColors)` An array of colors to use for a series of visual elements representing data (eg columns, bars, pie slices), any of which may be adjacent to any other.
    `void` | `setDataLabelProperties(DrawLabel dataLabelProperties)` Properties for data label
    `void` | `setDataLineProperties(DrawLine dataLineProperties)` Properties for lines that show data (as opposed to gradations or borders around the data area).
    `void` | `setDataLineType(DataLineType dataLineType)` How to draw lines between adjacent data points in Line and Scatter charts.
    `void` | `setDataMargin(int dataMargin)` For rectangular charts (bar, column, line), margin around the inside of the main chart area, so that data elements are not flush to edge.
    `void` | `setDataOutlineProperties(DrawItem dataOutlineProperties)` Properties for lines that outline a data shape (in filled charts such as area or radar charts).
    `void` | `setDataPointProperties(DrawItem dataPointProperties)` Common properties to apply for all data points (see `showDataPoints`).
    `void` | `setDataPointSize(int dataPointSize)` Size in pixels for data points drawn for line, area, radar and other chart types.
    `void` | `setDataShapeProperties(DrawPath dataShapeProperties)` Properties for data shapes (filled areas in area or radar charts).
    `void` | `setDataValueFormatter(ValueFormatter formatter)` Formatter to apply to values displayed in the hover labels and other value labels
    `void` | `setDecimalPrecision(int decimalPrecision)` Default precision used when formatting float numbers for axis labels
    `static void` | `setDefaultProperties(FacetChart facetChartProperties)` Class level method to set the default properties of this class.
    `void` | `setDiscontinuousLines(java.lang.Boolean discontinuousLines)` Whether to treat non-numeric values in the dataset as indicating a break in the data line.
    `void` | `setDoughnutHoleProperties(DrawOval doughnutHoleProperties)` Properties for doughnut hole
    `void` | `setDoughnutRatio(float doughnutRatio)` If showing a doughnut hole (see `showDoughnut`), ratio of the size of the doughnut hole to the size of the overall pie chart, as a number between 0 to 1.
    `void` | `setErrorBarColorMutePercent(float errorBarColorMutePercent)` This property helps specify the color of the error bars and its value must be a number between -100 and 100.
    `void` | `setErrorBarWidth(int errorBarWidth)` Width of the horizontal line of the "T"-shape portion of the error bar).
    `void` | `setErrorLineProperties(DrawLine errorLineProperties)` Properties of the lines used to draw error bars (short, horizontal lines at the low and high metric values, and a vertical connecting line).
    `void` | `setExpectedValueLineProperties(DrawItem expectedValueLineProperties)` Properties for the `line drawn at the mean value`.
    `void` | `setExtraAxisMetrics(java.lang.String... extraAxisMetrics)` Defines the set of metrics that will be plotted as additional vertical axes.
    `void` | `setExtraAxisSettings(MetricSettings... extraAxisSettings)` For charts will multiple vertical axes, optionally provides settings for how each `extra axis metric` is plotted.
    `void` | `setFacets(Facet... facets)` Set the facets for this chart.
    `void` | `setFilled(java.lang.Boolean filled)` Whether shapes are filled, for example, whether a multi-series line chart appears as a stack of filled regions as opposed to just multiple lines.
    `void` | `setGradationLabelProperties(DrawLabel gradationLabelProperties)` Properties for gradation labels
    `void` | `setGradationLineProperties(DrawLine gradationLineProperties)` Properties for gradation lines
    `void` | `setGradationTickMarkLength(int gradationTickMarkLength)` Length of the tick marks used to denote the gradations of any `extra value axes`.
    `void` | `setGradationZeroLineProperties(DrawLine gradationZeroLineProperties)` Properties for the gradation line drawn for zero (slightly thicker by default).
    `void` | `setHighErrorMetric(java.lang.String highErrorMetric)` See `lowErrorMetric`.
    `void` | `setHoverLabelProperties(DrawLabel hoverLabelProperties)` Properties for text in a floating label that represents the data value shown whenever the mouse moves withing the main chart area when `showValueOnHover` is enabled.
    `void` | `setHoverRectProperties(DrawRect hoverRectProperties)` Properties for rectangle that drawed behind of a floating hover label that represents the data value.
    `void` | `setJavaScriptObject(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `void` | `setLabelCollapseMode(LabelCollapseMode labelCollapseMode)` What to do when there are too many data points to be able to show labels for every data point at the current chart size - see `LabelCollapseMode`.
    `void` | `setLegendItemPadding(int legendItemPadding)` Padding between each swatch and label pair.
    `void` | `setLegendLabelProperties(DrawLabel legendLabelProperties)` Properties for labels shown next to legend color swatches.
    `void` | `setLegendMargin(int legendMargin)` Space between the legend and the chart rect or axis labels (whatever the legend is adjacent to.
    `void` | `setLegendPadding(int legendPadding)` Padding around the legend as a whole.
    `void` | `setLegendRectProperties(DrawRect legendRectProperties)` Properties for rectangle around the legend as a whole.
    `void` | `setLegendSwatchProperties(DrawRect legendSwatchProperties)` Properties for the swatches of color shown in the legend.
    `void` | `setLegendSwatchSize(int legendSwatchSize)` Size of individual color swatches in legend.
    `void` | `setLegendTextPadding(int legendTextPadding)` Padding between color swatch and its label.
    `void` | `setLogBase(int logBase)` When `useLogGradations`, base value for logarithmic gradation lines.
    `void` | `setLogGradations(float... logGradations)` When `useLogGradations` is set, gradation lines to show in between powers, expressed as a series of integer or float values between 1 and `logBase`.
    `com.smartgwt.logicalstructure.core.LogicalStructureObject` | `setLogicalStructure(com.smartgwt.logicalstructure.widgets.chart.FacetChartLogicalStructure s)`
    `void` | `setLogScale(java.lang.Boolean logScale)` Whether to use logarithmic scaling for values.
    `void` | `setLowErrorMetric(java.lang.String lowErrorMetric)` `lowErrorMetric` and `highErrorMetric` can be used to cause error bars to appear above and below the main data point.
    `void` | `setMaxBarThickness(int maxBarThickness)` Bars will not be drawn over this thickness, instead, margins will be increased.
    `void` | `setMinBarThickness(int minBarThickness)` If bars would be smaller than this size, margins are reduced until bars overlap.
    `void` | `setMinLabelGap(java.lang.Integer minLabelGap)` Minimum gap between labels on the X axis before some labels are omitted or larger time granularity is shown (eg show days instead of hours) based on the `labelCollapseMode`.
    `void` | `setPieBorderProperties(DrawOval pieBorderProperties)` Properties for the border around a pie chart.
    `void` | `setPieLabelAngleStart(int pieLabelAngleStart)` Angle where first label is placed in a Pie chart in stacked mode, in degrees.
    `void` | `setPieLabelLineExtent(int pieLabelLineExtent)` How far label lines stick out of the pie radius in a Pie chart in stacked mode.
    `void` | `setPieLabelLineProperties(DrawLine pieLabelLineProperties)` Properties for pie label line
    `void` | `setPieRingBorderProperties(DrawOval pieRingBorderProperties)` Properties for pie ring border
    `void` | `setPieSliceProperties(DrawSector pieSliceProperties)` Properties for pie slices
    `void` | `setPointClickHandler(ChartPointClickHandler handler)` Apply a handler to fire when `showDataPoints` is true, and the user clicks on a point.
    `void` | `setPointHoverCustomizer(ChartPointHoverCustomizer hoverCustomizer)` Display custom HTML when `showDataPoints` is true and the mouse hovers over a point.
    `void` | `setPointShapes(PointShape... pointShapes)` For charts where `showDataPoints` is enabled, this property specifies an array of geometric shapes to draw for the data points of each series.
    `void` | `setProbabilityMetric(java.lang.String probabilityMetric)` The "id" of the metric facet value that assigns a probability to each combination of facets and their values.
    `void` | `setRadarBackgroundProperties(DrawOval radarBackgroundProperties)` Properties for radar background
    `void` | `setRadialLabelOffset(int radialLabelOffset)` Distance in pixels that radial labels are offset from the outside of the circle.
    `void` | `setRegressionLineProperties(DrawLine regressionLineProperties)` Properties for the `regression line`.
    `void` | `setRegressionLineType(RegressionLineType regressionLineType)` Regression algorithm used for the `regression line`.
    `void` | `setRegressionPolynomialDegree(int regressionPolynomialDegree)` For scatter plots only, specify the degree of polynomial to use for any polynomial regression that is calculated.
    `void` | `setRotateLabels(LabelRotationMode rotateLabels)` This property controls whether to rotate the labels on the X-axis.
    `void` | `setShadowProperties(DrawOval shadowProperties)` Properties for shadows.
    `void` | `setShowChartRect(java.lang.Boolean showChartRect)` Whether to show a rectangular shape around the area of the chart where data is plotted.
    `void` | `setShowDataAxisLabel(java.lang.Boolean showDataAxisLabel)` Whether to show a label for the data axis as a whole (the data axis is where labels for each data point appear).
    `void` | `setShowDataPoints(java.lang.Boolean showDataPoints)` For line charts, whether to show data points for each individual data value.
    `void` | `setShowDataValues(boolean showDataValues)` Should data values be shown as text labels near the shape representing the value, for example, above columns of a column chart, or adjacent to points in a line chart?
    `void` | `setShowDoughnut(java.lang.Boolean showDoughnut)` Whether to show a "doughnut hole" in the middle of pie charts.
    `void` | `setShowExpectedValueLine(java.lang.Boolean showExpectedValueLine)` Display a line at the `mean value`.
    `void` | `setShowGradationsOverData(java.lang.Boolean showGradationsOverData)` If set, gradation lines are drawn on top of data rather than underneath.
    `void` | `setShowInlineLabels(java.lang.Boolean showInlineLabels)` Causes labels for the X axis to be shown above the axis and to the right of the gradation line they label, making for a vertically more compact chart at the risk of gradation labels being partially obscured by data values.
    `void` | `setShowLegend(java.lang.Boolean showLegend)` The legend is automatically shown for charts that need it (generally, multi-series charts) but can be forced off by setting showLegend to false.
    `void` | `setShowRadarGradationLabels(java.lang.Boolean showRadarGradationLabels)` Whether to show gradation labels in radar charts.
    `void` | `setShowRegressionLine(java.lang.Boolean showRegressionLine)` For scatter plots only, whether to display a regression curve that best fits the data of the two metric facet values.
    `void` | `setShowScatterLines(java.lang.Boolean showScatterLines)` Whether to draw lines between adjacent data points in "Scatter" plots.
    `void` | `setShowShadows(java.lang.Boolean showShadows)` Whether to automatically show shadows for various charts.
    `void` | `setShowStandardDeviationLines(java.lang.Boolean showStandardDeviationLines)` Display multiple `standard deviations` away from the mean as lines.
    `void` | `setShowStatisticsOverData(java.lang.Boolean showStatisticsOverData)` If set, the `mean line`, `standard deviation lines`, `standard deviation bands`, and `regression curves` are drawn on top of the data rather than underneath.
    `void` | `setShowTitle(java.lang.Boolean showTitle)` Whether to show a title.
    `void` | `setShowValueAxisLabel(java.lang.Boolean showValueAxisLabel)` Whether to show the `valueTitle` as a label on the value axis.
    `void` | `setShowValueOnHover(java.lang.Boolean showValueOnHover)` Shows the value of the nearest data value in a floating label whenever the mouse moves within the main chart area.
    `void` | `setStacked(java.lang.Boolean stacked)` Whether to use stacking for charts where this makes sense (column, area, pie, line and radar charts).
    `void` | `setStandardDeviationBandProperties(DrawItem... standardDeviationBandProperties)` An Array of DrawRect properties to specify the bands between the `standard deviation lines`.
    `void` | `setStandardDeviationLineProperties(DrawItem standardDeviationLineProperties)` Properties for the `standard deviation lines`.
    `void` | `setStandardDeviations(java.lang.Float[] standardDeviations)` When `showStandardDeviationLines` is set, the number of standard deviation lines drawn and their respective standard deviation away from the mean are specified by this property.
    `void` | `setStyleName(java.lang.String styleName)` Default styleName for the chart.
    `void` | `setTickMarkToValueAxisMargin(int tickMarkToValueAxisMargin)` Margin between the tick marks and the labels of the `extra value axes`.
    `void` | `setTitle(java.lang.String title)` Title for the chart as a whole.
    `void` | `setTitleProperties(DrawLabel titleProperties)` Properties for title label.
    `void` | `setUseAutoGradients(java.lang.Boolean useAutoGradients)` Causes the chart to use the colors specified in `dataColors` but specify chart-specific gradients based on the primary data color per chart type.
    `void` | `setUseLogGradations(java.lang.Boolean useLogGradations)` Whether to use classic logarithmic gradations, where each order of magnitude is shown as a gradation as well as a few intervening lines.
    `void` | `setUseMultiplePointShapes(java.lang.Boolean useMultiplePointShapes)` Whether the chart should use multiple shapes to show data points.
    `void` | `setUseSymmetricStandardDeviations(java.lang.Boolean useSymmetricStandardDeviations)` Whether to display both the positive and negative of the `standard deviations`.
    `void` | `setValueAxisLabelProperties(DrawLabel valueAxisLabelProperties)` Properties for labels of value axis.
    `void` | `setValueAxisMargin(int valueAxisMargin)` Margin between `multiple value axes`.
    `void` | `setValueLineProperties(DrawLine valueLineProperties)` Properties for a "value line" - a line shows where a particular discrete value is placed, eg, vertical lines connecting points of a line chart to the X axis, or radial lines in a Radar chart.
    `void` | `setValueProperty(java.lang.String valueProperty)` Property in each record that holds a data value.
    `void` | `setValueTitle(java.lang.String valueTitle)` A label for the data values, such as "Sales in Thousands", typically used as the label for the value axis.
    `void` | `setXAxisMetric(java.lang.String xAxisMetric)` For scatter charts only, the "id" of the metric facet value to use for the x-axis.
    `void` | `setXAxisValueFormatter(ValueFormatter formatter)` Formatter to apply to values displayed in the gradation labels on the x-axis.
    `void` | `setYAxisMetric(java.lang.String yAxisMetric)` For scatter charts only, the "id" of the metric facet value to use for the y-axis.
    `void` | `setYAxisValueFormatter(ValueFormatter formatter)` Formatter to apply to values displayed in the gradation labels on the y-axis.
    `void` | `setZoomChartProperties(FacetChart zoomChartProperties)` Properties to further configure the `zoomChart`.
    `void` | `setZoomEndValue(java.lang.Object zoomEndValue)` For a `zoomed chart`, end value of the data range shown in the main chart.
    `void` | `setZoomLogScale(java.lang.Boolean zoomLogScale)` By default when `canZoom` is enabled, the `zoomChart` uses logarithmic scaling so that spikes in the data don't result in a zoomed chart that is mostly a flat line.
    `void` | `setZoomMutePercent(float zoomMutePercent)` `colorMutePercent` to use for the `zoomChart`.
    `void` | `setZoomSelectionChartProperties(FacetChart zoomSelectionChartProperties)` Properties to further configure the `zoomSelectionChart`.
    `void` | `setZoomShowSelection(java.lang.Boolean zoomShowSelection)` Whether the selected range should be shown in a different style, which can be configured via `zoomSelectionChartProperties`.
    `void` | `setZoomStartPosition(ZoomStartPosition zoomStartPosition)` For a `zoomed chart`, determines what portion of the overall dataset should be initially shown in the main chart.
    `void` | `setZoomStartValue(java.lang.Object zoomStartValue)` For a `zoomed chart`, start value of the data range shown in the main chart.
    `void` | `zoomTo(java.lang.Object startValue, java.lang.Object endValue)` For a `zoomed chart`, simultaneously sets the `zoomStartValue` and `zoomEndValue`.

    - ### Methods inherited from class com.smartgwt.client.widgets.drawing.DrawPane

      `addDrawItem, createLinearGradient, createRadialGradient, createSimpleGradient, destroyItems, erase, getCanDrag, getDataURL, getDataURL, getDrawItems, getRotation, getSvgString, getTranslate, getZoomLevel, rotate, setCanDrag, setDefaultProperties, setDrawItems, setLogicalStructure, setRotation, setTranslate, setZoomLevel, zoom, zoom`

    - ### Methods inherited from class com.smartgwt.client.widgets.Canvas

      `addChild, addChild, addChild, addChild, addChild, addClickHandler, addDoubleClickHandler, addDragMoveHandler, addDragRepositionMoveHandler, addDragRepositionStartHandler, addDragRepositionStopHandler, addDragResizeMoveHandler, addDragResizeStartHandler, addDragResizeStopHandler, addDragStartHandler, addDragStopHandler, addDropHandler, addDropMoveHandler, addDropOutHandler, addDropOverHandler, addFocusChangedHandler, addHoverHandler, addHoverHiddenHandler, addKeyDownHandler, addKeyPressHandler, addMouseDownHandler, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseStillDownHandler, addMouseUpHandler, addMouseWheelHandler, addMovedHandler, addParentMovedHandler, addPeer, addPeer, addPeer, addPeer, addResizedHandler, addRightMouseDownHandler, addScrolledHandler, addShowContextMenuHandler, addStyleName, addVisibilityChangedHandler, adjustForContent, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateHide, animateHide, animateHide, animateMove, animateMove, animateMove, animateMove, animateRect, animateRect, animateRect, animateRect, animateResize, animateResize, animateResize, animateResize, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateShow, animateShow, animateShow, asSGWTComponent, blur, bringToFront, clear, clickMaskUp, clickMaskUp, contains, contains, containsEvent, containsFocus, containsPoint, containsPoint, deparent, depeer, disable, enable, focus, focusInNextTabElement, focusInPreviousTabElement, getAbsoluteLeft, getAbsoluteTop, getAccessKey, getAnimateAcceleration, getAnimateFadeTime, getAnimateHideAcceleration, getAnimateHideTime, getAnimateMoveAcceleration, getAnimateMoveTime, getAnimateRectAcceleration, getAnimateRectTime, getAnimateResizeAcceleration, getAnimateResizeTime, getAnimateScrollAcceleration, getAnimateScrollTime, getAnimateShowAcceleration, getAnimateShowEffect, getAnimateShowTime, getAnimateTime, getAppImgDir, getAriaRole, getAutoDraw, getAutoShowParent, getBackgroundColor, getBackgroundImage, getBackgroundPosition, getBackgroundRepeat, getBorder, getBottom, getById, getByJSObject, getByLocalId, getCanAcceptDrop, getCanDragReposition, getCanDragResize, getCanDragScroll, getCanDrop, getCanDropBefore, getCanFocus, getCanHover, getCanSelectText, getCanvasAutoChild, getCanvasItem, getChildren, getChildrenSnapResizeToGrid, getChildrenSnapToGrid, getClassName, getContentElement, getContents, getContextMenu, getCursor, getDataPath, getDefaultHeight, getDefaultWidth, getDestroyed, getDestroying, getDisabled, getDisabledCursor, getDoubleClickDelay, getDragAppearance, getDragIntersectStyle, getDragOpacity, getDragRepositionAppearance, getDragRepositionCursor, getDragResizeAppearance, getDragScrollDelay, getDragStartDistance, getDragTarget, getDragType, getDropTypes, getDynamicContents, getEdgeBackgroundColor, getEdgeCenterBackgroundColor, getEdgeImage, getEdgeMarginSize, getEdgeOffset, getEdgeOpacity, getEdgeShowCenter, getEdgeSize, getEventEdge, getEventEdge, getExtraSpace, getFacetId, getFormItemAutoChild, getFullDataPath, getGroupBorderCSS, getGroupLabelBackgroundColor, getGroupLabelStyleName, getGroupTitle, getHeight, getHeightAsString, getHideUsingDisplayNone, getHoverAlign, getHoverAutoDestroy, getHoverComponent, getHoverDelay, getHoverHeight, getHoverHTML, getHoverMoveWithMouse, getHoverOpacity, getHoverStyle, getHoverVAlign, getHoverWidth, getHoverWrap, getHSnapOrigin, getHSnapOrigin, getHSnapPosition, getHSnapPosition, getHtmlPosition, getImage, getImgURL, getImgURL, getInnerContentHeight, getInnerContentWidth, getInnerHeight, getInnerWidth, getIsGroup, getKeepInParentRect, getLayoutAlign, getLeft, getLeftAsString, getLocateChildrenBy, getLocateChildrenType, getLocatePeersBy, getLocatePeersType, getMargin, getMasterElement, getMatchElement, getMaxHeight, getMaxWidth, getMenuConstructor, getMinHeight, getMinWidth, getMouseStillDownDelay, getMouseStillDownInitialDelay, getNextZIndex, getNoDoubleClicks, getOffsetHeight, getOffsetWidth, getOffsetX, getOffsetY, getOpacity, getOuterElement, getOverflow, getPadding, getPageBottom, getPageLeft, getPageRect, getPageRight, getPageTop, getParentElement, getPeers, getPercentBox, getPercentSource, getPosition, getPrefix, getPrintChildrenAbsolutelyPositioned, getPrintHTML, getPrompt, getRect, getRedrawOnResize, getResizeBarTarget, getResizeFrom, getRight, getScrollbarSize, getScrollBottom, getScrollHeight, getScrollLeft, getScrollRight, getScrollTop, getScrollWidth, getShadowDepth, getShadowImage, getShadowOffset, getShadowSoftness, getShouldPrint, getShowCustomScrollbars, getShowDragShadow, getShowEdges, getShowHover, getShowHoverComponents, getShowResizeBar, getShowShadow, getSkinImgDir, getSnapAxis, getSnapEdge, getSnapHDirection, getSnapHGap, getSnapOffsetLeft, getSnapOffsetTop, getSnapOnDrop, getSnapResizeToGrid, getSnapTo, getSnapToGrid, getSnapVDirection, getSnapVGap, getTabIndex, getTestInstance, getTooltip, getTop, getTopAsString, getTopElement, getUseBackMask, getUseOpacityFilter, getValuesManager, getViewportHeight, getViewportWidth, getVisibility, getVisibleHeight, getVisibleWidth, getVSnapOrigin, getVSnapOrigin, getVSnapPosition, getVSnapPosition, getWidth, getWidthAsString, getZIndex, handleHover, hide, hideClickMask, hideClickMask, hideContextMenu, imgHTML, imgHTML, imgHTML, intersects, isDirty, isDisabled, isDrawn, isVisible, keyUp, layoutChildren, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, markForDestroy, markForRedraw, markForRedraw, moveAbove, moveBelow, moveBy, moveTo, onAttach, onDetach, onInit, parentResized, printComponents, redraw, redraw, removeChild, removeChild, removePeer, removePeer, resizeBy, resizeTo, resizeTo, scrollBy, scrollByPercent, scrollTo, scrollTo, scrollTo, scrollToBottom, scrollToLeft, scrollToPercent, scrollToRight, scrollToTop, sendToBack, setAccessKey, setAlign, setAllowExternalFilters, setAnimateAcceleration, setAnimateFadeTime, setAnimateHideAcceleration, setAnimateHideTime, setAnimateMoveAcceleration, setAnimateMoveTime, setAnimateRectAcceleration, setAnimateRectTime, setAnimateResizeAcceleration, setAnimateResizeTime, setAnimateScrollAcceleration, setAnimateScrollTime, setAnimateShowAcceleration, setAnimateShowEffect, setAnimateShowTime, setAnimateTime, setAppImgDir, setAriaRole, setAriaState, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setAutoDraw, setAutoHeight, setAutoShowParent, setAutoWidth, setBackgroundColor, setBackgroundImage, setBackgroundPosition, setBackgroundRepeat, setBorder, setBottom, setCanAcceptDrop, setCanDragReposition, setCanDragResize, setCanDragScroll, setCanDrop, setCanDropBefore, setCanFocus, setCanHover, setCanSelectText, setCanvasItem, setChildren, setChildrenSnapResizeToGrid, setChildrenSnapToGrid, setContents, setContextMenu, setCursor, setDataPath, setDefaultHeight, setDefaultProperties, setDefaultWidth, setDisabled, setDisabledCursor, setDoubleClickDelay, setDragAppearance, setDragIntersectStyle, setDragOpacity, setDragRepositionAppearance, setDragRepositionCursor, setDragResizeAppearance, setDragScrollDelay, setDragStartDistance, setDragTarget, setDragType, setDropTypes, setDynamicContents, setEdgeBackgroundColor, setEdgeCenterBackgroundColor, setEdgeImage, setEdgeMarginSize, setEdgeOffset, setEdgeOpacity, setEdgeShowCenter, setEdgeSize, setExtraSpace, setFacetId, setGroupBorderCSS, setGroupLabelBackgroundColor, setGroupLabelStyleName, setGroupTitle, setHeight, setHeight, setHeight100, setHideUsingDisplayNone, setHoverAlign, setHoverAutoDestroy, setHoverDelay, setHoverHeight, setHoverMoveWithMouse, setHoverOpacity, setHoverStyle, setHoverVAlign, setHoverWidth, setHoverWrap, setHtmlPosition, setImage, setImage, setIsGroup, setKeepInParentRect, setKeepInParentRect, setKeepInParentRect, setLayoutAlign, setLayoutAlign, setLeft, setLeft, setLocateChildrenBy, setLocateChildrenType, setLocatePeersBy, setLocatePeersType, setLogicalStructure, setMargin, setMatchElement, setMaxHeight, setMaxWidth, setMenuConstructor, setMinHeight, setMinWidth, setMouseStillDownDelay, setMouseStillDownInitialDelay, setNeverUseFilters, setNoDoubleClicks, setOpacity, setOverflow, setPadding, setPageLeft, setPageTop, setParentElement, setPeers, setPercentBox, setPercentSource, setPosition, setPrefix, setPrintChildrenAbsolutelyPositioned, setPrompt, setRect, setRect, setRedrawOnResize, setResizeBarTarget, setResizeFrom, setResizeFrom, setRight, setScrollbarConstructor, setScrollbarSize, setShadowDepth, setShadowImage, setShadowOffset, setShadowSoftness, setShouldPrint, setShowCustomScrollbars, setShowDragShadow, setShowEdges, setShowHover, setShowHoverComponents, setShowResizeBar, setShowShadow, setSkinImgDir, setSmoothFade, setSnapAxis, setSnapEdge, setSnapHDirection, setSnapHGap, setSnapOffsetLeft, setSnapOffsetTop, setSnapOnDrop, setSnapResizeToGrid, setSnapTo, setSnapToGrid, setSnapVDirection, setSnapVGap, setTabIndex, setTooltip, setTop, setTop, setUseBackMask, setUseOpacityFilter, setValuesManager, setVisibility, setVisible, setWidth, setWidth, setWidth100, setZIndex, shouldDragScroll, show, showClickMask, showNextTo, showNextTo, showNextTo, showNextTo, showPrintPreview, showPrintPreview, showPrintPreview, showPrintPreview, showRecursively, updateHover, updateHover, updateShadow, visibleAtPoint, willAcceptDrop`

    - ### Methods inherited from class com.smartgwt.client.widgets.BaseWidget

      `addDrawHandler, destroy, doAddHandler, doInit, doOnRender, draw, equals, error, errorIfNotCreated, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDateArray, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsFloatArray, getAttributeAsInt, getAttributeAsIntArray, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsRecord, getAttributeAsString, getAttributeAsStringArray, getConfig, getDOM, getElement, getElement, getHandlerCount, getID, getInnerHTML, getJsObj, getOrCreateJsObj, getRef, getScClassName, hashCode, initNativeObject, internalSetID, internalSetID, isConfigOnly, isCreated, onBind, onDestroy, onDraw, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setConfig, setConfigOnly, setDragTracker, setElement, setHtmlElement, setID, setLogicalStructure, setNullProperty, setPosition, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setScClassName, toString`

    - ### Methods inherited from class com.google.gwt.user.client.ui.Widget

      `addAttachHandler, addBitlessDomHandler, addDomHandler, addHandler, asWidget, asWidgetOrNull, createHandlerManager, delegateEvent, doAttachChildren, doDetachChildren, fireEvent, getLayoutData, getParent, isAttached, isOrWasAttached, onBrowserEvent, onLoad, onUnload, removeFromParent, setLayoutData, sinkEvents`

    - ### Methods inherited from class com.google.gwt.user.client.ui.UIObject

      `addStyleDependentName, ensureDebugId, ensureDebugId, ensureDebugId, getStyleElement, getStyleName, getStylePrimaryName, getStylePrimaryName, isVisible, onEnsureDebugId, removeStyleDependentName, removeStyleName, resolvePotentialElement, setElement, setPixelSize, setSize, setStyleDependentName, setStyleName, setStyleName, setStyleName, setStylePrimaryName, setStylePrimaryName, setVisible, sinkBitlessEvent, unsinkEvents`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

- - ### Constructor Detail

    - #### FacetChart

          public FacetChart()

    - #### FacetChart

          public FacetChart(com.google.gwt.core.client.JavaScriptObject jsObj)

  - ### Method Detail

    - #### getOrCreateRef

          public static FacetChart getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### setJavaScriptObject

          public void setJavaScriptObject(com.google.gwt.core.client.JavaScriptObject jsObj)

      Overrides:
        `setJavaScriptObject` in class `DrawPane`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                     Canvas defaults)

      Changes the defaults for Canvas AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties.
      See Also:
        `AutoChildUsage`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                     FormItem defaults)

      Changes the defaults for FormItem AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties.
      See Also:
        `AutoChildUsage`

    - #### create

          protected com.google.gwt.core.client.JavaScriptObject create()

      Overrides:
        `create` in class `DrawPane`

    - #### setAutoRotateLabels

          public void setAutoRotateLabels(java.lang.Boolean autoRotateLabels)
                                   throws java.lang.IllegalStateException

      Deprecated. As of Smart GWT 9.0 this property is replaced by the property `rotateLabels`. Setting rotateLabels to "auto" is equivalent to setting autoRotateLabels to `true`. Setting rotateLabels to "never" is equivalent to setting autoRotateLabels to `false`.
      Whether to automatically rotate labels if needed in order to make them legible and non-overlapping.
      Parameters:
        `autoRotateLabels` - autoRotateLabels Default value is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getAutoRotateLabels

          public java.lang.Boolean getAutoRotateLabels()

      Deprecated. As of Smart GWT 9.0 this property is replaced by the property `rotateLabels`. Setting rotateLabels to "auto" is equivalent to setting autoRotateLabels to `true`. Setting rotateLabels to "never" is equivalent to setting autoRotateLabels to `false`.
      Whether to automatically rotate labels if needed in order to make them legible and non-overlapping.
      Returns:
        Boolean

    - #### setBackgroundBandProperties

          public void setBackgroundBandProperties(DrawRect backgroundBandProperties)
                                           throws java.lang.IllegalStateException

      Properties for background band
      Parameters:
        `backgroundBandProperties` - backgroundBandProperties Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getBackgroundBandProperties

          public DrawRect getBackgroundBandProperties()

      Properties for background band
      Returns:
        DrawRect

    - #### setBandedBackground

          public void setBandedBackground(java.lang.Boolean bandedBackground)
                                   throws java.lang.IllegalStateException

      Whether to show alternating color bands in the background of chart. See `backgroundBandProperties`.
      Parameters:
        `bandedBackground` - bandedBackground Default value is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getBandedBackground

          public java.lang.Boolean getBandedBackground()

      Whether to show alternating color bands in the background of chart. See `backgroundBandProperties`.
      Returns:
        Boolean

    - #### setBandedStandardDeviations

          public void setBandedStandardDeviations(java.lang.Boolean bandedStandardDeviations)
                                           throws java.lang.IllegalStateException

      Whether to show color bands between the `standard deviation` lines.

      Standard deviation bands are not available for pie or radar charts.

      Parameters:
        `bandedStandardDeviations` - bandedStandardDeviations Default value is false
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `setStandardDeviationBandProperties(com.smartgwt.client.widgets.drawing.DrawItem...)`

    - #### getBandedStandardDeviations

          public java.lang.Boolean getBandedStandardDeviations()

      Whether to show color bands between the `standard deviation` lines.

      Standard deviation bands are not available for pie or radar charts.

      Returns:
        Boolean
      See Also:
        `getStandardDeviationBandProperties()`

    - #### setBarMargin

          public void setBarMargin(int barMargin)
                            throws java.lang.IllegalStateException

      Distance between bars. May be reduced if bars would be smaller than `minBarThickness`.
      Parameters:
        `barMargin` - barMargin Default value is 4
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getBarMargin

          public int getBarMargin()

      Distance between bars. May be reduced if bars would be smaller than `minBarThickness`.
      Returns:
        int

    - #### setBarProperties

          public void setBarProperties(DrawRect barProperties)

      Properties for bar
      Parameters:
        `barProperties` - barProperties Default value is null

    - #### getBarProperties

          public DrawRect getBarProperties()

      Properties for bar
      Returns:
        DrawRect

    - #### setCanMoveAxes

          public void setCanMoveAxes(java.lang.Boolean canMoveAxes)
                              throws java.lang.IllegalStateException

      Whether the positions of value axes can be changed. The default is true for charts with three or more vertical, value axes.
      Parameters:
        `canMoveAxes` - canMoveAxes Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getCanMoveAxes

          public java.lang.Boolean getCanMoveAxes()

      Whether the positions of value axes can be changed. The default is true for charts with three or more vertical, value axes.
      Returns:
        Boolean

    - #### setCanZoom

          public void setCanZoom(java.lang.Boolean canZoom)
                          throws java.lang.IllegalStateException

      Enables "zooming" on the X axis, specifically, only a portion of the overall dataset is shown in the main chart, and a `second smaller chart` appears with slider controls allowing a range to be selected for display in the main chart.

      A `labelCollapseMode` is automatically enabled if unset and is based on the type of the first non-null data value.

      Parameters:
        `canZoom` - canZoom Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getCanZoom

          public java.lang.Boolean getCanZoom()

      Enables "zooming" on the X axis, specifically, only a portion of the overall dataset is shown in the main chart, and a `second smaller chart` appears with slider controls allowing a range to be selected for display in the main chart.

      A `labelCollapseMode` is automatically enabled if unset and is based on the type of the first non-null data value.

      Returns:
        Boolean

    - #### setChartRectMargin

          public void setChartRectMargin(int chartRectMargin)
                                  throws java.lang.IllegalStateException

      Margin around the main chart rect: between title and chart, between chart and axis labels, and chart rect and right edge of chart.
      Parameters:
        `chartRectMargin` - chartRectMargin Default value is 5
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getChartRectMargin

          public int getChartRectMargin()

      Margin around the main chart rect: between title and chart, between chart and axis labels, and chart rect and right edge of chart.
      Returns:
        int

    - #### setChartRectProperties

          public void setChartRectProperties(DrawRect chartRectProperties)

      Properties for chart rect
      Parameters:
        `chartRectProperties` - chartRectProperties Default value is null

    - #### getChartRectProperties

          public DrawRect getChartRectProperties()

      Properties for chart rect
      Returns:
        DrawRect

    - #### setChartType

          public void setChartType(ChartType chartType)

      See `ChartType` for a list of known types - Column, Bar, Line, Pie, Doughnut, Area, and Radar charts are supported.
      If this method is called after the component has been drawn/initialized: Method to change the current `chartType`. Will redraw the chart if drawn. Will use default settings for the new chart type for `stacked` and `filled` if those values are null.
      Parameters:
        `chartType` - new chart type. Default value is "Column"

    - #### getChartType

          public ChartType getChartType()

      See `ChartType` for a list of known types - Column, Bar, Line, Pie, Doughnut, Area, and Radar charts are supported.
      Returns:
        ChartType

    - #### setClusterMarginRatio

          public void setClusterMarginRatio(float clusterMarginRatio)
                                     throws java.lang.IllegalStateException

      For clustered charts, ratio between margins between individual bars and margins between clusters.
      Parameters:
        `clusterMarginRatio` - clusterMarginRatio Default value is 4
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getClusterMarginRatio

          public float getClusterMarginRatio()

      For clustered charts, ratio between margins between individual bars and margins between clusters.
      Returns:
        float

    - #### setColorMutePercent

          public void setColorMutePercent(java.lang.Float colorMutePercent)
                                   throws java.lang.IllegalStateException

      Should be set to a number between -100 and 100. If set, all colors in the chart are "muted" by this percentage by shifting them toward white (or for negative numbers, toward black).
      Parameters:
        `colorMutePercent` - colorMutePercent Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getColorMutePercent

          public java.lang.Float getColorMutePercent()

      Should be set to a number between -100 and 100. If set, all colors in the chart are "muted" by this percentage by shifting them toward white (or for negative numbers, toward black).
      Returns:
        Float

    - #### setDataAxisLabelProperties

          public void setDataAxisLabelProperties(DrawLabel dataAxisLabelProperties)

      Properties for labels of data axis.
      Parameters:
        `dataAxisLabelProperties` - dataAxisLabelProperties Default value is null

    - #### getDataAxisLabelProperties

          public DrawLabel getDataAxisLabelProperties()

      Properties for labels of data axis.
      Returns:
        DrawLabel

    - #### setDataColors

          public void setDataColors(java.lang.String... dataColors)
                             throws java.lang.IllegalStateException

      An array of colors to use for a series of visual elements representing data (eg columns, bars, pie slices), any of which may be adjacent to any other.

      Colors must be in the format of a leading hash (#) plus 6 hexadecimal digits, for example, "#FFFFFF" is white, "#FF0000" is pure red.

      Parameters:
        `dataColors` - . See `CSSColor`. Default value is see below
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getDataColors

          public java.lang.String[] getDataColors()

      An array of colors to use for a series of visual elements representing data (eg columns, bars, pie slices), any of which may be adjacent to any other.

      Colors must be in the format of a leading hash (#) plus 6 hexadecimal digits, for example, "#FFFFFF" is white, "#FF0000" is pure red.

      Returns:
        . See `CSSColor`

    - #### setDataLabelProperties

          public void setDataLabelProperties(DrawLabel dataLabelProperties)

      Properties for data label
      Parameters:
        `dataLabelProperties` - dataLabelProperties Default value is null

    - #### getDataLabelProperties

          public DrawLabel getDataLabelProperties()

      Properties for data label
      Returns:
        DrawLabel

    - #### setDataLineProperties

          public void setDataLineProperties(DrawLine dataLineProperties)
                                     throws java.lang.IllegalStateException

      Properties for lines that show data (as opposed to gradations or borders around the data area).
      Parameters:
        `dataLineProperties` - dataLineProperties Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getDataLineProperties

          public DrawLine getDataLineProperties()

      Properties for lines that show data (as opposed to gradations or borders around the data area).
      Returns:
        DrawLine

    - #### setDataLineType

          public void setDataLineType(DataLineType dataLineType)

      How to draw lines between adjacent data points in Line and Scatter charts. See `DataLineType`.

      Does not apply to boundary lines for shapes in Area or Radar plots.
      If this method is called after the component has been drawn/initialized: Method to change the current `dataLineType`. Will redraw the chart if drawn.

      Parameters:
        `dataLineType` - ow to draw lines between adjacent data points in Line and Scatter charts. Default value is null

    - #### getDataLineType

          public DataLineType getDataLineType()

      How to draw lines between adjacent data points in Line and Scatter charts. See `DataLineType`.

      Does not apply to boundary lines for shapes in Area or Radar plots.

      Returns:
        DataLineType

    - #### setDataMargin

          public void setDataMargin(int dataMargin)
                             throws java.lang.IllegalStateException

      For rectangular charts (bar, column, line), margin around the inside of the main chart area, so that data elements are not flush to edge.
      Parameters:
        `dataMargin` - dataMargin Default value is 10
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getDataMargin

          public int getDataMargin()

      For rectangular charts (bar, column, line), margin around the inside of the main chart area, so that data elements are not flush to edge.
      Returns:
        int

    - #### setDataOutlineProperties

          public void setDataOutlineProperties(DrawItem dataOutlineProperties)
                                        throws java.lang.IllegalStateException

      Properties for lines that outline a data shape (in filled charts such as area or radar charts).
      Parameters:
        `dataOutlineProperties` - dataOutlineProperties Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getDataOutlineProperties

          public DrawItem getDataOutlineProperties()

      Properties for lines that outline a data shape (in filled charts such as area or radar charts).
      Returns:
        DrawItem

    - #### setDataPointProperties

          public void setDataPointProperties(DrawItem dataPointProperties)
                                      throws java.lang.IllegalStateException

      Common properties to apply for all data points (see `showDataPoints`).
      Parameters:
        `dataPointProperties` - dataPointProperties Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getDataPointProperties

          public DrawItem getDataPointProperties()

      Common properties to apply for all data points (see `showDataPoints`).
      Returns:
        DrawItem

    - #### setDataPointSize

          public void setDataPointSize(int dataPointSize)
                                throws java.lang.IllegalStateException

      Size in pixels for data points drawn for line, area, radar and other chart types.
      Parameters:
        `dataPointSize` - dataPointSize Default value is 5
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getDataPointSize

          public int getDataPointSize()

      Size in pixels for data points drawn for line, area, radar and other chart types.
      Returns:
        int

    - #### setDataShapeProperties

          public void setDataShapeProperties(DrawPath dataShapeProperties)
                                      throws java.lang.IllegalStateException

      Properties for data shapes (filled areas in area or radar charts).
      Parameters:
        `dataShapeProperties` - dataShapeProperties Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getDataShapeProperties

          public DrawPath getDataShapeProperties()

      Properties for data shapes (filled areas in area or radar charts).
      Returns:
        DrawPath

    - #### setDecimalPrecision

          public void setDecimalPrecision(int decimalPrecision)
                                   throws java.lang.IllegalStateException

      Default precision used when formatting float numbers for axis labels
      Parameters:
        `decimalPrecision` - decimalPrecision Default value is 2
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getDecimalPrecision

          public int getDecimalPrecision()

      Default precision used when formatting float numbers for axis labels
      Returns:
        int

    - #### setDiscontinuousLines

          public void setDiscontinuousLines(java.lang.Boolean discontinuousLines)

      Whether to treat non-numeric values in the dataset as indicating a break in the data line. If set to `false` then null values are ignored. Defaults to `true` for `filled` charts and to `false` for line charts.
      Parameters:
        `discontinuousLines` - discontinuousLines Default value is null

    - #### getDiscontinuousLines

          public java.lang.Boolean getDiscontinuousLines()

      Whether to treat non-numeric values in the dataset as indicating a break in the data line. If set to `false` then null values are ignored. Defaults to `true` for `filled` charts and to `false` for line charts.
      Returns:
        Boolean

    - #### setDoughnutHoleProperties

          public void setDoughnutHoleProperties(DrawOval doughnutHoleProperties)

      Properties for doughnut hole
      Parameters:
        `doughnutHoleProperties` - doughnutHoleProperties Default value is null

    - #### getDoughnutHoleProperties

          public DrawOval getDoughnutHoleProperties()

      Properties for doughnut hole
      Returns:
        DrawOval

    - #### setDoughnutRatio

          public void setDoughnutRatio(float doughnutRatio)
                                throws java.lang.IllegalStateException

      If showing a doughnut hole (see `showDoughnut`), ratio of the size of the doughnut hole to the size of the overall pie chart, as a number between 0 to 1.
      Parameters:
        `doughnutRatio` - doughnutRatio Default value is 0.2
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getDoughnutRatio

          public float getDoughnutRatio()

      If showing a doughnut hole (see `showDoughnut`), ratio of the size of the doughnut hole to the size of the overall pie chart, as a number between 0 to 1.
      Returns:
        float

    - #### setErrorBarColorMutePercent

          public void setErrorBarColorMutePercent(float errorBarColorMutePercent)
                                           throws java.lang.IllegalStateException

      This property helps specify the color of the error bars and its value must be a number between -100 and 100. Error bars have the same color as the data line, but the colors are actually "muted" by this percentage by shifting them toward white (or for negative numbers, toward black). The default is to darken the data colors by 60% to get the error bar colors.
      Parameters:
        `errorBarColorMutePercent` - errorBarColorMutePercent Default value is -60
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getErrorBarColorMutePercent

          public float getErrorBarColorMutePercent()

      This property helps specify the color of the error bars and its value must be a number between -100 and 100. Error bars have the same color as the data line, but the colors are actually "muted" by this percentage by shifting them toward white (or for negative numbers, toward black). The default is to darken the data colors by 60% to get the error bar colors.
      Returns:
        float

    - #### setErrorBarWidth

          public void setErrorBarWidth(int errorBarWidth)
                                throws java.lang.IllegalStateException

      Width of the horizontal line of the "T"-shape portion of the error bar).
      Parameters:
        `errorBarWidth` - errorBarWidth Default value is 6
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getErrorBarWidth

          public int getErrorBarWidth()

      Width of the horizontal line of the "T"-shape portion of the error bar).
      Returns:
        int

    - #### setErrorLineProperties

          public void setErrorLineProperties(DrawLine errorLineProperties)
                                      throws java.lang.IllegalStateException

      Properties of the lines used to draw error bars (short, horizontal lines at the low and high metric values, and a vertical connecting line).

      Note that the `lineColor` property has no effect as the color of the error bars is derived from the color of the data line.

      Parameters:
        `errorLineProperties` - errorLineProperties Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `setErrorBarColorMutePercent(float)`

    - #### getErrorLineProperties

          public DrawLine getErrorLineProperties()

      Properties of the lines used to draw error bars (short, horizontal lines at the low and high metric values, and a vertical connecting line).

      Note that the `lineColor` property has no effect as the color of the error bars is derived from the color of the data line.

      Returns:
        DrawLine
      See Also:
        `getErrorBarColorMutePercent()`

    - #### setExpectedValueLineProperties

          public void setExpectedValueLineProperties(DrawItem expectedValueLineProperties)
                                              throws java.lang.IllegalStateException

      Properties for the `line drawn at the mean value`.

      Note that for rectangular charts the properties are for a `DrawLine`, and for radar charts the properties are for a `DrawOval`.

      Parameters:
        `expectedValueLineProperties` - expectedValueLineProperties Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getExpectedValueLineProperties

          public DrawItem getExpectedValueLineProperties()

      Properties for the `line drawn at the mean value`.

      Note that for rectangular charts the properties are for a `DrawLine`, and for radar charts the properties are for a `DrawOval`.

      Returns:
        DrawItem

    - #### setExtraAxisMetrics

          public void setExtraAxisMetrics(java.lang.String... extraAxisMetrics)
                                   throws java.lang.IllegalStateException

      Defines the set of metrics that will be plotted as additional vertical axes. See the main `FacetChart` docs for an overview of how multi-axis charts are used.

      Each metric corresponds to different value property of the data records and superimposes its drawn data onto the chart rectangle. The value properties are called metrics, and they can be either the `valueProperty` or the "id" of a `FacetValue` of the inlined `Facet` (which is then called the metric facet). Each value axis has its own gradations that are shown as tick marks along the length of the axis. This property, extraAxisMetrics, specifies the metrics to use for additional value axes to the main value axis.

      The additional value axis may have their own gradations, chart type, log scale, data colors and gradients, and other chart properties. These properties are specified with the `extraAxisSettings` property.

      Value axes, including the main value axis, are labelled in the legend along with representations of the charted data. The labels are taken from the `title` of each metric's FacetValue (or the `valueTitle` if the metric is the `valueProperty`).

      The order of the metrics determines the position of the corresponding axes on the chart as well as the z-ordering of the corresponding data lines. The first and second extra value axes are placed to the right of the chart rectangle, and any remaining extra value axes are placed to the left of the main value axis (and therefore to the left of the chart rectangle).

      Parameters:
        `extraAxisMetrics` - . See `String`. Default value is []
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getExtraAxisMetrics

          public java.lang.String[] getExtraAxisMetrics()

      Defines the set of metrics that will be plotted as additional vertical axes. See the main `FacetChart` docs for an overview of how multi-axis charts are used.

      Each metric corresponds to different value property of the data records and superimposes its drawn data onto the chart rectangle. The value properties are called metrics, and they can be either the `valueProperty` or the "id" of a `FacetValue` of the inlined `Facet` (which is then called the metric facet). Each value axis has its own gradations that are shown as tick marks along the length of the axis. This property, extraAxisMetrics, specifies the metrics to use for additional value axes to the main value axis.

      The additional value axis may have their own gradations, chart type, log scale, data colors and gradients, and other chart properties. These properties are specified with the `extraAxisSettings` property.

      Value axes, including the main value axis, are labelled in the legend along with representations of the charted data. The labels are taken from the `title` of each metric's FacetValue (or the `valueTitle` if the metric is the `valueProperty`).

      The order of the metrics determines the position of the corresponding axes on the chart as well as the z-ordering of the corresponding data lines. The first and second extra value axes are placed to the right of the chart rectangle, and any remaining extra value axes are placed to the left of the main value axis (and therefore to the left of the chart rectangle).

      Returns:
        . See `String`

    - #### setExtraAxisSettings

          public void setExtraAxisSettings(MetricSettings... extraAxisSettings)
                                    throws java.lang.IllegalStateException

      For charts will multiple vertical axes, optionally provides settings for how each `extra axis metric` is plotted. See the main `FacetChart` docs for an overview of how multi-axis charts are used.

      The chart of each metric's values may be of any rectangular chart type that uses a vertical value axis ("Column", "Area", and "Line"). Because the charts will be superimposed over the same drawing area, there can only be one "Column" chart and one "Area" chart. The column chart is placed on the bottom followed by the area chart, and then the line charts are drawn on top in the order of their metric in the `extraAxisMetrics` array. If the `chartType`s are left unspecified then by default the first metric will be drawn as columns and the remaining will be drawn as lines.

      Parameters:
        `extraAxisSettings` - extraAxisSettings Default value is []
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getExtraAxisSettings

          public MetricSettings[] getExtraAxisSettings()

      For charts will multiple vertical axes, optionally provides settings for how each `extra axis metric` is plotted. See the main `FacetChart` docs for an overview of how multi-axis charts are used.

      The chart of each metric's values may be of any rectangular chart type that uses a vertical value axis ("Column", "Area", and "Line"). Because the charts will be superimposed over the same drawing area, there can only be one "Column" chart and one "Area" chart. The column chart is placed on the bottom followed by the area chart, and then the line charts are drawn on top in the order of their metric in the `extraAxisMetrics` array. If the `chartType`s are left unspecified then by default the first metric will be drawn as columns and the remaining will be drawn as lines.

      Returns:
        MetricSettings

    - #### setFilled

          public void setFilled(java.lang.Boolean filled)

      Whether shapes are filled, for example, whether a multi-series line chart appears as a stack of filled regions as opposed to just multiple lines.

      If unset, fills will be automatically used when there are multiple facets and stacking is active (so Line and Radar charts will show stacked regions).

      You can explicitly set filled:false to create multi-facet Line or Radar charts where translucent regions overlap, or filled:true to fill in a single-facet Line or Radar chart.
      If this method is called after the component has been drawn/initialized: Method to change `filled`. Use null to apply a default value for the current `chartType`.

      Parameters:
        `filled` - new value. Default value is null

    - #### getFilled

          public java.lang.Boolean getFilled()

      Whether shapes are filled, for example, whether a multi-series line chart appears as a stack of filled regions as opposed to just multiple lines.

      If unset, fills will be automatically used when there are multiple facets and stacking is active (so Line and Radar charts will show stacked regions).

      You can explicitly set filled:false to create multi-facet Line or Radar charts where translucent regions overlap, or filled:true to fill in a single-facet Line or Radar chart.

      Returns:
        Boolean

    - #### setGradationLabelProperties

          public void setGradationLabelProperties(DrawLabel gradationLabelProperties)
                                           throws java.lang.IllegalStateException

      Properties for gradation labels
      Parameters:
        `gradationLabelProperties` - gradationLabelProperties Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getGradationLabelProperties

          public DrawLabel getGradationLabelProperties()

      Properties for gradation labels
      Returns:
        DrawLabel

    - #### setGradationLineProperties

          public void setGradationLineProperties(DrawLine gradationLineProperties)
                                          throws java.lang.IllegalStateException

      Properties for gradation lines
      Parameters:
        `gradationLineProperties` - gradationLineProperties Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getGradationLineProperties

          public DrawLine getGradationLineProperties()

      Properties for gradation lines
      Returns:
        DrawLine

    - #### setGradationTickMarkLength

          public void setGradationTickMarkLength(int gradationTickMarkLength)
                                          throws java.lang.IllegalStateException

      Length of the tick marks used to denote the gradations of any `extra value axes`.
      Parameters:
        `gradationTickMarkLength` - gradationTickMarkLength Default value is 5
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getGradationTickMarkLength

          public int getGradationTickMarkLength()

      Length of the tick marks used to denote the gradations of any `extra value axes`.
      Returns:
        int

    - #### setGradationZeroLineProperties

          public void setGradationZeroLineProperties(DrawLine gradationZeroLineProperties)
                                              throws java.lang.IllegalStateException

      Properties for the gradation line drawn for zero (slightly thicker by default).
      Parameters:
        `gradationZeroLineProperties` - gradationZeroLineProperties Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getGradationZeroLineProperties

          public DrawLine getGradationZeroLineProperties()

      Properties for the gradation line drawn for zero (slightly thicker by default).
      Returns:
        DrawLine

    - #### setHighErrorMetric

          public void setHighErrorMetric(java.lang.String highErrorMetric)
                                  throws java.lang.IllegalStateException

      See `lowErrorMetric`.
      Parameters:
        `highErrorMetric` - . See `String`. Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getHighErrorMetric

          public java.lang.String getHighErrorMetric()

      See `lowErrorMetric`.
      Returns:
        . See `String`

    - #### setHoverLabelProperties

          public void setHoverLabelProperties(DrawLabel hoverLabelProperties)
                                       throws java.lang.IllegalStateException

      Properties for text in a floating label that represents the data value shown whenever the mouse moves withing the main chart area when `showValueOnHover` is enabled.
      Parameters:
        `hoverLabelProperties` - hoverLabelProperties Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getHoverLabelProperties

          public DrawLabel getHoverLabelProperties()

      Properties for text in a floating label that represents the data value shown whenever the mouse moves withing the main chart area when `showValueOnHover` is enabled.
      Returns:
        DrawLabel

    - #### setHoverRectProperties

          public void setHoverRectProperties(DrawRect hoverRectProperties)
                                      throws java.lang.IllegalStateException

      Properties for rectangle that drawed behind of a floating hover label that represents the data value. See `showValueOnHover` for more details.
      Parameters:
        `hoverRectProperties` - hoverRectProperties Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getHoverRectProperties

          public DrawRect getHoverRectProperties()

      Properties for rectangle that drawed behind of a floating hover label that represents the data value. See `showValueOnHover` for more details.
      Returns:
        DrawRect

    - #### setLabelCollapseMode

          public void setLabelCollapseMode(LabelCollapseMode labelCollapseMode)
                                    throws java.lang.IllegalStateException

      What to do when there are too many data points to be able to show labels for every data point at the current chart size - see `LabelCollapseMode`.

      Each of the possible strategies is re-applied when the user resizes the chart as a whole, so if labels are omitted the user can make them visible via resize or zoom.

      Note that if the labelCollapseMode is "time" or "numeric" then the `data` must be initially sorted with the `data label facet`'s values in ascending order.

      Parameters:
        `labelCollapseMode` - labelCollapseMode Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getLabelCollapseMode

          public LabelCollapseMode getLabelCollapseMode()

      What to do when there are too many data points to be able to show labels for every data point at the current chart size - see `LabelCollapseMode`.

      Each of the possible strategies is re-applied when the user resizes the chart as a whole, so if labels are omitted the user can make them visible via resize or zoom.

      Note that if the labelCollapseMode is "time" or "numeric" then the `data` must be initially sorted with the `data label facet`'s values in ascending order.

      Returns:
        LabelCollapseMode

    - #### setLegendItemPadding

          public void setLegendItemPadding(int legendItemPadding)
                                    throws java.lang.IllegalStateException

      Padding between each swatch and label pair.
      Parameters:
        `legendItemPadding` - legendItemPadding Default value is 5
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getLegendItemPadding

          public int getLegendItemPadding()

      Padding between each swatch and label pair.
      Returns:
        int

    - #### setLegendLabelProperties

          public void setLegendLabelProperties(DrawLabel legendLabelProperties)
                                        throws java.lang.IllegalStateException

      Properties for labels shown next to legend color swatches.
      Parameters:
        `legendLabelProperties` - legendLabelProperties Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getLegendLabelProperties

          public DrawLabel getLegendLabelProperties()

      Properties for labels shown next to legend color swatches.
      Returns:
        DrawLabel

    - #### setLegendMargin

          public void setLegendMargin(int legendMargin)
                               throws java.lang.IllegalStateException

      Space between the legend and the chart rect or axis labels (whatever the legend is adjacent to.
      Parameters:
        `legendMargin` - legendMargin Default value is 10
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getLegendMargin

          public int getLegendMargin()

      Space between the legend and the chart rect or axis labels (whatever the legend is adjacent to.
      Returns:
        int

    - #### setLegendPadding

          public void setLegendPadding(int legendPadding)
                                throws java.lang.IllegalStateException

      Padding around the legend as a whole.
      Parameters:
        `legendPadding` - legendPadding Default value is 5
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getLegendPadding

          public int getLegendPadding()

      Padding around the legend as a whole.
      Returns:
        int

    - #### setLegendRectProperties

          public void setLegendRectProperties(DrawRect legendRectProperties)
                                       throws java.lang.IllegalStateException

      Properties for rectangle around the legend as a whole.
      Parameters:
        `legendRectProperties` - legendRectProperties Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getLegendRectProperties

          public DrawRect getLegendRectProperties()

      Properties for rectangle around the legend as a whole.
      Returns:
        DrawRect

    - #### setLegendSwatchProperties

          public void setLegendSwatchProperties(DrawRect legendSwatchProperties)
                                         throws java.lang.IllegalStateException

      Properties for the swatches of color shown in the legend.
      Parameters:
        `legendSwatchProperties` - legendSwatchProperties Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getLegendSwatchProperties

          public DrawRect getLegendSwatchProperties()

      Properties for the swatches of color shown in the legend.
      Returns:
        DrawRect

    - #### setLegendSwatchSize

          public void setLegendSwatchSize(int legendSwatchSize)
                                   throws java.lang.IllegalStateException

      Size of individual color swatches in legend.
      Parameters:
        `legendSwatchSize` - legendSwatchSize Default value is 16
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getLegendSwatchSize

          public int getLegendSwatchSize()

      Size of individual color swatches in legend.
      Returns:
        int

    - #### setLegendTextPadding

          public void setLegendTextPadding(int legendTextPadding)
                                    throws java.lang.IllegalStateException

      Padding between color swatch and its label.
      Parameters:
        `legendTextPadding` - legendTextPadding Default value is 5
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getLegendTextPadding

          public int getLegendTextPadding()

      Padding between color swatch and its label.
      Returns:
        int

    - #### setLogBase

          public void setLogBase(int logBase)
                          throws java.lang.IllegalStateException

      When `useLogGradations`, base value for logarithmic gradation lines. Gradation lines will be shown at every power of this value plus intervening values specified by `logGradations`.
      Parameters:
        `logBase` - logBase Default value is 10
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getLogBase

          public int getLogBase()

      When `useLogGradations`, base value for logarithmic gradation lines. Gradation lines will be shown at every power of this value plus intervening values specified by `logGradations`.
      Returns:
        int

    - #### setLogGradations

          public void setLogGradations(float... logGradations)
                                throws java.lang.IllegalStateException

      When `useLogGradations` is set, gradation lines to show in between powers, expressed as a series of integer or float values between 1 and `logBase`.

      Some common possibilities (for base 10):

               [ 1 ] // show only orders of magnitude (0.1, 1, 10, 100, etc)
               [ 1, 5 ] // show only orders of magnitude plus halfway mark
               [ 1, 2, 4, 8 ] // show powers of 2 between orders
               [ 1, 2.5, 5, 7.5 ] // show quarters

      Or base 2:

               [ 1 ]
               [ 1, 1.5 ]

      Parameters:
        `logGradations` - logGradations Default value is [ 1,2,4,6,8 ]
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getLogGradations

          public float[] getLogGradations()

      When `useLogGradations` is set, gradation lines to show in between powers, expressed as a series of integer or float values between 1 and `logBase`.

      Some common possibilities (for base 10):

               [ 1 ] // show only orders of magnitude (0.1, 1, 10, 100, etc)
               [ 1, 5 ] // show only orders of magnitude plus halfway mark
               [ 1, 2, 4, 8 ] // show powers of 2 between orders
               [ 1, 2.5, 5, 7.5 ] // show quarters

      Or base 2:

               [ 1 ]
               [ 1, 1.5 ]

      Returns:
        float

    - #### setLogScale

          public void setLogScale(java.lang.Boolean logScale)
                           throws java.lang.IllegalStateException

      Whether to use logarithmic scaling for values.

      Logarithmic scale charts show an equivalent percentage increase as equivalent distance on the chart. That is, 10 and 100 are the same distance apart as 100 and 1000 (each being a 10 times or 1000% increase).

      Parameters:
        `logScale` - logScale Default value is false
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getLogScale

          public java.lang.Boolean getLogScale()

      Whether to use logarithmic scaling for values.

      Logarithmic scale charts show an equivalent percentage increase as equivalent distance on the chart. That is, 10 and 100 are the same distance apart as 100 and 1000 (each being a 10 times or 1000% increase).

      Returns:
        Boolean

    - #### setLowErrorMetric

          public void setLowErrorMetric(java.lang.String lowErrorMetric)
                                 throws java.lang.IllegalStateException

      `lowErrorMetric` and `highErrorMetric` can be used to cause error bars to appear above and below the main data point.

      `lowErrorMetric` and `highErrorMetric` provide the name of an additional attributes that appears in each Record holding the low error value and high error value respectively.

      Error bars are supported for single-axis charts only.

      Parameters:
        `lowErrorMetric` - . See `String`. Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        Error Bars Example

    - #### getLowErrorMetric

          public java.lang.String getLowErrorMetric()

      `lowErrorMetric` and `highErrorMetric` can be used to cause error bars to appear above and below the main data point.

      `lowErrorMetric` and `highErrorMetric` provide the name of an additional attributes that appears in each Record holding the low error value and high error value respectively.

      Error bars are supported for single-axis charts only.

      Returns:
        . See `String`
      See Also:
        Error Bars Example

    - #### setMaxBarThickness

          public void setMaxBarThickness(int maxBarThickness)
                                  throws java.lang.IllegalStateException

      Bars will not be drawn over this thickness, instead, margins will be increased.
      Parameters:
        `maxBarThickness` - maxBarThickness Default value is 150
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getMaxBarThickness

          public int getMaxBarThickness()

      Bars will not be drawn over this thickness, instead, margins will be increased.
      Returns:
        int

    - #### setMinBarThickness

          public void setMinBarThickness(int minBarThickness)
                                  throws java.lang.IllegalStateException

      If bars would be smaller than this size, margins are reduced until bars overlap.
      Parameters:
        `minBarThickness` - minBarThickness Default value is 4
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getMinBarThickness

          public int getMinBarThickness()

      If bars would be smaller than this size, margins are reduced until bars overlap.
      Returns:
        int

    - #### setMinLabelGap

          public void setMinLabelGap(java.lang.Integer minLabelGap)
                              throws java.lang.IllegalStateException

      Minimum gap between labels on the X axis before some labels are omitted or larger time granularity is shown (eg show days instead of hours) based on the `labelCollapseMode`.

      Default is based on label orientation. If labels are vertical, the minimum gap is the height of half a line of text. If horizontal it's the width of 4 "X" letters.

      Parameters:
        `minLabelGap` - minLabelGap Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getMinLabelGap

          public java.lang.Integer getMinLabelGap()

      Minimum gap between labels on the X axis before some labels are omitted or larger time granularity is shown (eg show days instead of hours) based on the `labelCollapseMode`.

      Default is based on label orientation. If labels are vertical, the minimum gap is the height of half a line of text. If horizontal it's the width of 4 "X" letters.

      Returns:
        Integer

    - #### setPieBorderProperties

          public void setPieBorderProperties(DrawOval pieBorderProperties)
                                      throws java.lang.IllegalStateException

      Properties for the border around a pie chart.
      Parameters:
        `pieBorderProperties` - pieBorderProperties Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getPieBorderProperties

          public DrawOval getPieBorderProperties()

      Properties for the border around a pie chart.
      Returns:
        DrawOval

    - #### setPieLabelAngleStart

          public void setPieLabelAngleStart(int pieLabelAngleStart)
                                     throws java.lang.IllegalStateException

      Angle where first label is placed in a Pie chart in stacked mode, in degrees.
      Parameters:
        `pieLabelAngleStart` - pieLabelAngleStart Default value is 20
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getPieLabelAngleStart

          public int getPieLabelAngleStart()

      Angle where first label is placed in a Pie chart in stacked mode, in degrees.
      Returns:
        int

    - #### setPieLabelLineExtent

          public void setPieLabelLineExtent(int pieLabelLineExtent)
                                     throws java.lang.IllegalStateException

      How far label lines stick out of the pie radius in a Pie chart in stacked mode.
      Parameters:
        `pieLabelLineExtent` - pieLabelLineExtent Default value is 7
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getPieLabelLineExtent

          public int getPieLabelLineExtent()

      How far label lines stick out of the pie radius in a Pie chart in stacked mode.
      Returns:
        int

    - #### setPieLabelLineProperties

          public void setPieLabelLineProperties(DrawLine pieLabelLineProperties)

      Properties for pie label line
      Parameters:
        `pieLabelLineProperties` - pieLabelLineProperties Default value is null

    - #### getPieLabelLineProperties

          public DrawLine getPieLabelLineProperties()

      Properties for pie label line
      Returns:
        DrawLine

    - #### setPieRingBorderProperties

          public void setPieRingBorderProperties(DrawOval pieRingBorderProperties)
                                          throws java.lang.IllegalStateException

      Properties for pie ring border
      Parameters:
        `pieRingBorderProperties` - pieRingBorderProperties Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getPieRingBorderProperties

          public DrawOval getPieRingBorderProperties()

      Properties for pie ring border
      Returns:
        DrawOval

    - #### setPieSliceProperties

          public void setPieSliceProperties(DrawSector pieSliceProperties)
                                     throws java.lang.IllegalStateException

      Properties for pie slices
      Parameters:
        `pieSliceProperties` - pieSliceProperties Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getPieSliceProperties

          public DrawSector getPieSliceProperties()

      Properties for pie slices
      Returns:
        DrawSector

    - #### setPointShapes

          public void setPointShapes(PointShape... pointShapes)
                              throws java.lang.IllegalStateException

      For charts where `showDataPoints` is enabled, this property specifies an array of geometric shapes to draw for the data points of each series.
      Parameters:
        `pointShapes` - pointShapes Default value is ["Oval", "Square", "Diamond", "Triangle"]
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getPointShapes

          public PointShape[] getPointShapes()

      For charts where `showDataPoints` is enabled, this property specifies an array of geometric shapes to draw for the data points of each series.
      Returns:
        PointShape

    - #### setProbabilityMetric

          public void setProbabilityMetric(java.lang.String probabilityMetric)
                                    throws java.lang.IllegalStateException

      The "id" of the metric facet value that assigns a probability to each combination of facets and their values. Each probability must be a non-negative number. These probabilities are used by all methods of FacetChart that calculate statistical values (e.g. `FacetChart.getMean` and `FacetChart.getStdDev`). The default value of this property is null which causes the FacetChart to assign probabilities to the data records according to a uniform probability distribution.

      Note that the FacetChart handles cases where the sum total of all probabilities in the `data` is not exactly one by scaling the assigned probabilities.

      Parameters:
        `probabilityMetric` - . See `String`. Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `getMean(java.lang.String)`, `getMedian(java.lang.String)`, `getStdDev(java.lang.String, boolean)`, `getVariance(java.lang.String, boolean)`

    - #### getProbabilityMetric

          public java.lang.String getProbabilityMetric()

      The "id" of the metric facet value that assigns a probability to each combination of facets and their values. Each probability must be a non-negative number. These probabilities are used by all methods of FacetChart that calculate statistical values (e.g. `FacetChart.getMean` and `FacetChart.getStdDev`). The default value of this property is null which causes the FacetChart to assign probabilities to the data records according to a uniform probability distribution.

      Note that the FacetChart handles cases where the sum total of all probabilities in the `data` is not exactly one by scaling the assigned probabilities.

      Returns:
        . See `String`
      See Also:
        `getMean(java.lang.String)`, `getMedian(java.lang.String)`, `getStdDev(java.lang.String, boolean)`, `getVariance(java.lang.String, boolean)`

    - #### setRadarBackgroundProperties

          public void setRadarBackgroundProperties(DrawOval radarBackgroundProperties)
                                            throws java.lang.IllegalStateException

      Properties for radar background
      Parameters:
        `radarBackgroundProperties` - radarBackgroundProperties Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getRadarBackgroundProperties

          public DrawOval getRadarBackgroundProperties()

      Properties for radar background
      Returns:
        DrawOval

    - #### setRadialLabelOffset

          public void setRadialLabelOffset(int radialLabelOffset)
                                    throws java.lang.IllegalStateException

      Distance in pixels that radial labels are offset from the outside of the circle.
      Parameters:
        `radialLabelOffset` - radialLabelOffset Default value is 5
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getRadialLabelOffset

          public int getRadialLabelOffset()

      Distance in pixels that radial labels are offset from the outside of the circle.
      Returns:
        int

    - #### setRegressionLineProperties

          public void setRegressionLineProperties(DrawLine regressionLineProperties)
                                           throws java.lang.IllegalStateException

      Properties for the `regression line`.
      Parameters:
        `regressionLineProperties` - regressionLineProperties Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getRegressionLineProperties

          public DrawLine getRegressionLineProperties()

      Properties for the `regression line`.
      Returns:
        DrawLine

    - #### setRegressionLineType

          public void setRegressionLineType(RegressionLineType regressionLineType)

      Regression algorithm used for the `regression line`.
      If this method is called after the component has been drawn/initialized: Setter for `RegressionLineType`.
      Parameters:
        `regressionLineType` - New value for this.regressionLineType. Default value is "line"

    - #### getRegressionLineType

          public RegressionLineType getRegressionLineType()

      Regression algorithm used for the `regression line`.
      Returns:
        RegressionLineType

    - #### setRegressionPolynomialDegree

          public void setRegressionPolynomialDegree(int regressionPolynomialDegree)

      For scatter plots only, specify the degree of polynomial to use for any polynomial regression that is calculated.
      If this method is called after the component has been drawn/initialized: Setter for `regressionPolynomialDegree`.
      Parameters:
        `regressionPolynomialDegree` - New value for this.regressionPolynomialDegree.. Default value is 3

    - #### getRegressionPolynomialDegree

          public int getRegressionPolynomialDegree()

      For scatter plots only, specify the degree of polynomial to use for any polynomial regression that is calculated.
      Returns:
        int

    - #### setRotateLabels

          public void setRotateLabels(LabelRotationMode rotateLabels)
                               throws java.lang.IllegalStateException

      This property controls whether to rotate the labels on the X-axis. If rotateLabels is "always" then all of the data labels will be rotated by 90 degrees. If rotateLabels is "auto" (the default) then the labels will only be rotated if it is required in order for the labels to be legible and non-overlapping. If rotateLabels is "never" then the labels will not be rotated.
      Parameters:
        `rotateLabels` - rotateLabels Default value is "auto"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getRotateLabels

          public LabelRotationMode getRotateLabels()

      This property controls whether to rotate the labels on the X-axis. If rotateLabels is "always" then all of the data labels will be rotated by 90 degrees. If rotateLabels is "auto" (the default) then the labels will only be rotated if it is required in order for the labels to be legible and non-overlapping. If rotateLabels is "never" then the labels will not be rotated.
      Returns:
        LabelRotationMode

    - #### setShadowProperties

          public void setShadowProperties(DrawOval shadowProperties)
                                   throws java.lang.IllegalStateException

      Properties for shadows.
      Parameters:
        `shadowProperties` - shadowProperties Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getShadowProperties

          public DrawOval getShadowProperties()

      Properties for shadows.
      Returns:
        DrawOval

    - #### setShowChartRect

          public void setShowChartRect(java.lang.Boolean showChartRect)
                                throws java.lang.IllegalStateException

      Whether to show a rectangular shape around the area of the chart where data is plotted.
      Parameters:
        `showChartRect` - showChartRect Default value is false
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getShowChartRect

          public java.lang.Boolean getShowChartRect()

      Whether to show a rectangular shape around the area of the chart where data is plotted.
      Returns:
        Boolean

    - #### setShowDataAxisLabel

          public void setShowDataAxisLabel(java.lang.Boolean showDataAxisLabel)
                                    throws java.lang.IllegalStateException

      Whether to show a label for the data axis as a whole (the data axis is where labels for each data point appear). If true, `title` for the data label facet will be shown as the label.

      Automatically disabled for non-rectangular charts (eg Pie, Radar).

      Parameters:
        `showDataAxisLabel` - showDataAxisLabel Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getShowDataAxisLabel

          public java.lang.Boolean getShowDataAxisLabel()

      Whether to show a label for the data axis as a whole (the data axis is where labels for each data point appear). If true, `title` for the data label facet will be shown as the label.

      Automatically disabled for non-rectangular charts (eg Pie, Radar).

      Returns:
        Boolean

    - #### setShowDataPoints

          public void setShowDataPoints(java.lang.Boolean showDataPoints)
                                 throws java.lang.IllegalStateException

      For line charts, whether to show data points for each individual data value.

      If shown, the `FacetChart.pointClick` and `FacetChart.getPointHoverHTML` APIs can be used to create interactivity.

      Parameters:
        `showDataPoints` - showDataPoints Default value is false
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getShowDataPoints

          public java.lang.Boolean getShowDataPoints()

      For line charts, whether to show data points for each individual data value.

      If shown, the `FacetChart.pointClick` and `FacetChart.getPointHoverHTML` APIs can be used to create interactivity.

      Returns:
        Boolean

    - #### setShowDataValues

          public void setShowDataValues(boolean showDataValues)
                                 throws java.lang.IllegalStateException

      Should data values be shown as text labels near the shape representing the value, for example, above columns of a column chart, or adjacent to points in a line chart?

      If set to false, then data values will not be shown.

      If set to true, data values will be shown unless the data density is high enough that labels will potentially overlap, in which case, data values will not be shown and `showValueOnHover` will be enabled instead.

      Parameters:
        `showDataValues` - showDataValues Default value is false
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getShowDataValues

          public boolean getShowDataValues()

      Should data values be shown as text labels near the shape representing the value, for example, above columns of a column chart, or adjacent to points in a line chart?

      If set to false, then data values will not be shown.

      If set to true, data values will be shown unless the data density is high enough that labels will potentially overlap, in which case, data values will not be shown and `showValueOnHover` will be enabled instead.

      Returns:
        boolean

    - #### setShowDoughnut

          public void setShowDoughnut(java.lang.Boolean showDoughnut)
                               throws java.lang.IllegalStateException

      Whether to show a "doughnut hole" in the middle of pie charts. Defaults to whether chartType is set to "Doughnut" (shown) vs "Pie" (not shown) but can be forced on or off via `showDoughnut`.
      Parameters:
        `showDoughnut` - showDoughnut Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getShowDoughnut

          public java.lang.Boolean getShowDoughnut()

      Whether to show a "doughnut hole" in the middle of pie charts. Defaults to whether chartType is set to "Doughnut" (shown) vs "Pie" (not shown) but can be forced on or off via `showDoughnut`.
      Returns:
        Boolean

    - #### setShowExpectedValueLine

          public void setShowExpectedValueLine(java.lang.Boolean showExpectedValueLine)
                                        throws java.lang.IllegalStateException

      Display a line at the `mean value`.

      Note that this expected value is computed using all of the data points, pooled across all facets. The computation relies only on the values of the main value axis metric and the `probability metric`.

      See http://en.wikipedia.org/wiki/Expected_value.

      Parameters:
        `showExpectedValueLine` - showExpectedValueLine Default value is false
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getShowExpectedValueLine

          public java.lang.Boolean getShowExpectedValueLine()

      Display a line at the `mean value`.

      Note that this expected value is computed using all of the data points, pooled across all facets. The computation relies only on the values of the main value axis metric and the `probability metric`.

      See http://en.wikipedia.org/wiki/Expected_value.

      Returns:
        Boolean

    - #### setShowGradationsOverData

          public void setShowGradationsOverData(java.lang.Boolean showGradationsOverData)
                                         throws java.lang.IllegalStateException

      If set, gradation lines are drawn on top of data rather than underneath.
      Parameters:
        `showGradationsOverData` - showGradationsOverData Default value is false
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getShowGradationsOverData

          public java.lang.Boolean getShowGradationsOverData()

      If set, gradation lines are drawn on top of data rather than underneath.
      Returns:
        Boolean

    - #### setShowInlineLabels

          public void setShowInlineLabels(java.lang.Boolean showInlineLabels)
                                   throws java.lang.IllegalStateException

      Causes labels for the X axis to be shown above the axis and to the right of the gradation line they label, making for a vertically more compact chart at the risk of gradation labels being partially obscured by data values. Also causes the last label to be skipped (no where to place it).
      Parameters:
        `showInlineLabels` - showInlineLabels Default value is false
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getShowInlineLabels

          public java.lang.Boolean getShowInlineLabels()

      Causes labels for the X axis to be shown above the axis and to the right of the gradation line they label, making for a vertically more compact chart at the risk of gradation labels being partially obscured by data values. Also causes the last label to be skipped (no where to place it).
      Returns:
        Boolean

    - #### setShowLegend

          public void setShowLegend(java.lang.Boolean showLegend)
                             throws java.lang.IllegalStateException

      The legend is automatically shown for charts that need it (generally, multi-series charts) but can be forced off by setting showLegend to false.
      Parameters:
        `showLegend` - showLegend Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getShowLegend

          public java.lang.Boolean getShowLegend()

      The legend is automatically shown for charts that need it (generally, multi-series charts) but can be forced off by setting showLegend to false.
      Returns:
        Boolean

    - #### setShowRadarGradationLabels

          public void setShowRadarGradationLabels(java.lang.Boolean showRadarGradationLabels)
                                           throws java.lang.IllegalStateException

      Whether to show gradation labels in radar charts.
      Parameters:
        `showRadarGradationLabels` - showRadarGradationLabels Default value is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getShowRadarGradationLabels

          public java.lang.Boolean getShowRadarGradationLabels()

      Whether to show gradation labels in radar charts.
      Returns:
        Boolean

    - #### setShowRegressionLine

          public void setShowRegressionLine(java.lang.Boolean showRegressionLine)

      For scatter plots only, whether to display a regression curve that best fits the data of the two metric facet values.

      The type of regression curve used depends on the `RegressionLineType` property, which can be:

      - "line" – to draw a linear regression curve, or
      - "polynomial" – to draw a polynomial regression curve (of degree `regressionPolynomialDegree`).

      Note that the regression is computed using all of the data points and it does not depend on the values of any non-metric facets. For example, adding a legend facet will not change the regression curve.

      See http://en.wikipedia.org/wiki/Simple_linear_regression. See http://en.wikipedia.org/wiki/Polynomial_regression.
      If this method is called after the component has been drawn/initialized: Setter for `showRegressionLine`.

      Parameters:
        `showRegressionLine` - New value for this.showRegressionLine.. Default value is false
      See Also:
        `setXAxisMetric(java.lang.String)`, `setYAxisMetric(java.lang.String)`, `setRegressionLineProperties(com.smartgwt.client.widgets.drawing.DrawLine)`

    - #### getShowRegressionLine

          public java.lang.Boolean getShowRegressionLine()

      For scatter plots only, whether to display a regression curve that best fits the data of the two metric facet values.

      The type of regression curve used depends on the `RegressionLineType` property, which can be:

      - "line" – to draw a linear regression curve, or
      - "polynomial" – to draw a polynomial regression curve (of degree `regressionPolynomialDegree`).

      Note that the regression is computed using all of the data points and it does not depend on the values of any non-metric facets. For example, adding a legend facet will not change the regression curve.

      See http://en.wikipedia.org/wiki/Simple_linear_regression. See http://en.wikipedia.org/wiki/Polynomial_regression.

      Returns:
        Boolean
      See Also:
        `getXAxisMetric()`, `getYAxisMetric()`, `getRegressionLineProperties()`

    - #### setShowScatterLines

          public void setShowScatterLines(java.lang.Boolean showScatterLines)

      Whether to draw lines between adjacent data points in "Scatter" plots. See also `DataLineType` for enabling smoothing.
      If this method is called after the component has been drawn/initialized: Method to change the current `showScatterLines`. Will redraw the chart if drawn.
      Parameters:
        `showScatterLines` - whether to draw lines between adjacent data points in "Scatter" plots. Default value is false
      See Also:
        Scatter Plot Example

    - #### getShowScatterLines

          public java.lang.Boolean getShowScatterLines()

      Whether to draw lines between adjacent data points in "Scatter" plots. See also `DataLineType` for enabling smoothing.
      Returns:
        Boolean
      See Also:
        Scatter Plot Example

    - #### setShowShadows

          public void setShowShadows(java.lang.Boolean showShadows)
                              throws java.lang.IllegalStateException

      Whether to automatically show shadows for various charts.
      Parameters:
        `showShadows` - showShadows Default value is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getShowShadows

          public java.lang.Boolean getShowShadows()

      Whether to automatically show shadows for various charts.
      Returns:
        Boolean

    - #### setShowStandardDeviationLines

          public void setShowStandardDeviationLines(java.lang.Boolean showStandardDeviationLines)
                                             throws java.lang.IllegalStateException

      Display multiple `standard deviations` away from the mean as lines. The exact deviations to display can be customized with `standardDeviations`.

      Note that these standard deviations are computed using all of the data points, pooled across all facets. The computation relies only on the values of the main value axis metric and the `probability metric`.

      See http://en.wikipedia.org/wiki/Standard_deviation.

      Parameters:
        `showStandardDeviationLines` - showStandardDeviationLines Default value is false
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getShowStandardDeviationLines

          public java.lang.Boolean getShowStandardDeviationLines()

      Display multiple `standard deviations` away from the mean as lines. The exact deviations to display can be customized with `standardDeviations`.

      Note that these standard deviations are computed using all of the data points, pooled across all facets. The computation relies only on the values of the main value axis metric and the `probability metric`.

      See http://en.wikipedia.org/wiki/Standard_deviation.

      Returns:
        Boolean

    - #### setShowStatisticsOverData

          public void setShowStatisticsOverData(java.lang.Boolean showStatisticsOverData)
                                         throws java.lang.IllegalStateException

      If set, the `mean line`, `standard deviation lines`, `standard deviation bands`, and `regression curves` are drawn on top of the data rather than underneath.
      Parameters:
        `showStatisticsOverData` - showStatisticsOverData Default value is false
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getShowStatisticsOverData

          public java.lang.Boolean getShowStatisticsOverData()

      If set, the `mean line`, `standard deviation lines`, `standard deviation bands`, and `regression curves` are drawn on top of the data rather than underneath.
      Returns:
        Boolean

    - #### setShowTitle

          public void setShowTitle(java.lang.Boolean showTitle)

      Whether to show a title.
      Parameters:
        `showTitle` - showTitle Default value is true

    - #### getShowTitle

          public java.lang.Boolean getShowTitle()

      Whether to show a title.
      Returns:
        Boolean

    - #### setShowValueAxisLabel

          public void setShowValueAxisLabel(java.lang.Boolean showValueAxisLabel)
                                     throws java.lang.IllegalStateException

      Whether to show the `valueTitle` as a label on the value axis.

      Automatically disabled for non-rectangular charts (eg Pie, Radar).

      Parameters:
        `showValueAxisLabel` - showValueAxisLabel Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getShowValueAxisLabel

          public java.lang.Boolean getShowValueAxisLabel()

      Whether to show the `valueTitle` as a label on the value axis.

      Automatically disabled for non-rectangular charts (eg Pie, Radar).

      Returns:
        Boolean

    - #### setShowValueOnHover

          public void setShowValueOnHover(java.lang.Boolean showValueOnHover)
                                   throws java.lang.IllegalStateException

      Shows the value of the nearest data value in a floating label whenever the mouse moves within the main chart area. The visual element representing the data value will also be emphasized by brightening or highlighting it (appearance differs by chart type).

      Calculates nearest value based on `FacetChart.getNearestDrawnValue`.

      The label's appearance is controlled by `hoverLabelProperties`.

      Parameters:
        `showValueOnHover` - showValueOnHover Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getShowValueOnHover

          public java.lang.Boolean getShowValueOnHover()

      Shows the value of the nearest data value in a floating label whenever the mouse moves within the main chart area. The visual element representing the data value will also be emphasized by brightening or highlighting it (appearance differs by chart type).

      Calculates nearest value based on `FacetChart.getNearestDrawnValue`.

      The label's appearance is controlled by `hoverLabelProperties`.

      Returns:
        Boolean

    - #### setStacked

          public void setStacked(java.lang.Boolean stacked)

      Whether to use stacking for charts where this makes sense (column, area, pie, line and radar charts). If stacked is not set and two facets are supplied, clustering is assumed. If null (the default), line charts will be unstacked, and others will be stacked.
      If this method is called after the component has been drawn/initialized: Method to change `stacked`. Use null to apply a default value for the current `chartType`.
      Parameters:
        `stacked` - new value. Default value is null

    - #### getStacked

          public java.lang.Boolean getStacked()

      Whether to use stacking for charts where this makes sense (column, area, pie, line and radar charts). If stacked is not set and two facets are supplied, clustering is assumed. If null (the default), line charts will be unstacked, and others will be stacked.
      Returns:
        Boolean

    - #### setStandardDeviationBandProperties

          public void setStandardDeviationBandProperties(DrawItem... standardDeviationBandProperties)
                                                  throws java.lang.IllegalStateException

      An Array of DrawRect properties to specify the bands between the `standard deviation lines`. The length of the Array must be one less than the length of the `standardDeviations` Array.

      Having no band between certain standard deviations from the mean can be specified by having a null element at the corresponding index of this Array.

      Note that if `useSymmetricStandardDeviations` is set then for each standard deviation band that is drawn a corresponding band will also be drawn on the opposite side of the mean line.

      Parameters:
        `standardDeviationBandProperties` - standardDeviationBandProperties Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getStandardDeviationBandProperties

          public DrawItem[] getStandardDeviationBandProperties()

      An Array of DrawRect properties to specify the bands between the `standard deviation lines`. The length of the Array must be one less than the length of the `standardDeviations` Array.

      Having no band between certain standard deviations from the mean can be specified by having a null element at the corresponding index of this Array.

      Note that if `useSymmetricStandardDeviations` is set then for each standard deviation band that is drawn a corresponding band will also be drawn on the opposite side of the mean line.

      Returns:
        DrawItem

    - #### setStandardDeviationLineProperties

          public void setStandardDeviationLineProperties(DrawItem standardDeviationLineProperties)
                                                  throws java.lang.IllegalStateException

      Properties for the `standard deviation lines`.

      Note that for rectangular charts the properties are for a `DrawLine`, and for radar charts the properties are for a `DrawOval`.

      Parameters:
        `standardDeviationLineProperties` - standardDeviationLineProperties Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getStandardDeviationLineProperties

          public DrawItem getStandardDeviationLineProperties()

      Properties for the `standard deviation lines`.

      Note that for rectangular charts the properties are for a `DrawLine`, and for radar charts the properties are for a `DrawOval`.

      Returns:
        DrawItem

    - #### setStyleName

          public void setStyleName(java.lang.String styleName)

      Default styleName for the chart.
      Overrides:
        `setStyleName` in class `Canvas`
      Parameters:
        `styleName` - . See `CSSStyleName`. Default value is "scChart"
      See Also:
        `Appearance overview and related methods`, CSS styles Example

    - #### getStyleName

          public java.lang.String getStyleName()

      Default styleName for the chart.
      Overrides:
        `getStyleName` in class `Canvas`
      Returns:
        . See `CSSStyleName`
      See Also:
        `Appearance overview and related methods`, CSS styles Example

    - #### setTickMarkToValueAxisMargin

          public void setTickMarkToValueAxisMargin(int tickMarkToValueAxisMargin)
                                            throws java.lang.IllegalStateException

      Margin between the tick marks and the labels of the `extra value axes`.
      Parameters:
        `tickMarkToValueAxisMargin` - tickMarkToValueAxisMargin Default value is 7
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getTickMarkToValueAxisMargin

          public int getTickMarkToValueAxisMargin()

      Margin between the tick marks and the labels of the `extra value axes`.
      Returns:
        int

    - #### setTitle

          public void setTitle(java.lang.String title)

      Title for the chart as a whole.
      Overrides:
        `setTitle` in class `Canvas`
      Parameters:
        `title` - . See `String`. Default value is null

    - #### getTitle

          public java.lang.String getTitle()

      Title for the chart as a whole.
      Overrides:
        `getTitle` in class `Canvas`
      Returns:
        . See `String`

    - #### setTitleProperties

          public void setTitleProperties(DrawLabel titleProperties)

      Properties for title label.
      Parameters:
        `titleProperties` - titleProperties Default value is null

    - #### getTitleProperties

          public DrawLabel getTitleProperties()

      Properties for title label.
      Returns:
        DrawLabel

    - #### setUseAutoGradients

          public void setUseAutoGradients(java.lang.Boolean useAutoGradients)
                                   throws java.lang.IllegalStateException

      Causes the chart to use the colors specified in `dataColors` but specify chart-specific gradients based on the primary data color per chart type.
      Parameters:
        `useAutoGradients` - useAutoGradients Default value is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getUseAutoGradients

          public java.lang.Boolean getUseAutoGradients()

      Causes the chart to use the colors specified in `dataColors` but specify chart-specific gradients based on the primary data color per chart type.
      Returns:
        Boolean

    - #### setUseLogGradations

          public void setUseLogGradations(java.lang.Boolean useLogGradations)
                                   throws java.lang.IllegalStateException

      Whether to use classic logarithmic gradations, where each order of magnitude is shown as a gradation as well as a few intervening lines. Gradations also begin and end on an order of magnitude. For example, 1,2,4,6,8,10,20,40,60,80,100.

      Default gradations can be overridden via `logBase` and `logGradations`.

      Parameters:
        `useLogGradations` - useLogGradations Default value is false
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getUseLogGradations

          public java.lang.Boolean getUseLogGradations()

      Whether to use classic logarithmic gradations, where each order of magnitude is shown as a gradation as well as a few intervening lines. Gradations also begin and end on an order of magnitude. For example, 1,2,4,6,8,10,20,40,60,80,100.

      Default gradations can be overridden via `logBase` and `logGradations`.

      Returns:
        Boolean

    - #### setUseMultiplePointShapes

          public void setUseMultiplePointShapes(java.lang.Boolean useMultiplePointShapes)

      Whether the chart should use multiple shapes to show data points. If set to `true` then the chart is allowed to use all `supported shapes`: circles, squares, diamonds, and triangles. If set to `false` then just the first supported shape (circles, for example) will be used.
      If this method is called after the component has been drawn/initialized: Setter for `useMultiplePointShapes`.
      Parameters:
        `useMultiplePointShapes` - Whether the chart should now use multiple shapes to show data points.. Default value is true

    - #### getUseMultiplePointShapes

          public java.lang.Boolean getUseMultiplePointShapes()

      Whether the chart should use multiple shapes to show data points. If set to `true` then the chart is allowed to use all `supported shapes`: circles, squares, diamonds, and triangles. If set to `false` then just the first supported shape (circles, for example) will be used.
      Returns:
        Boolean

    - #### setUseSymmetricStandardDeviations

          public void setUseSymmetricStandardDeviations(java.lang.Boolean useSymmetricStandardDeviations)
                                                 throws java.lang.IllegalStateException

      Whether to display both the positive and negative of the `standard deviations`.
      Parameters:
        `useSymmetricStandardDeviations` - useSymmetricStandardDeviations Default value is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getUseSymmetricStandardDeviations

          public java.lang.Boolean getUseSymmetricStandardDeviations()

      Whether to display both the positive and negative of the `standard deviations`.
      Returns:
        Boolean

    - #### setValueAxisLabelProperties

          public void setValueAxisLabelProperties(DrawLabel valueAxisLabelProperties)

      Properties for labels of value axis.
      Parameters:
        `valueAxisLabelProperties` - valueAxisLabelProperties Default value is null

    - #### getValueAxisLabelProperties

          public DrawLabel getValueAxisLabelProperties()

      Properties for labels of value axis.
      Returns:
        DrawLabel

    - #### setValueAxisMargin

          public void setValueAxisMargin(int valueAxisMargin)
                                  throws java.lang.IllegalStateException

      Margin between `multiple value axes`.
      Parameters:
        `valueAxisMargin` - valueAxisMargin Default value is 10
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getValueAxisMargin

          public int getValueAxisMargin()

      Margin between `multiple value axes`.
      Returns:
        int

    - #### setValueLineProperties

          public void setValueLineProperties(DrawLine valueLineProperties)
                                      throws java.lang.IllegalStateException

      Properties for a "value line" - a line shows where a particular discrete value is placed, eg, vertical lines connecting points of a line chart to the X axis, or radial lines in a Radar chart.
      Parameters:
        `valueLineProperties` - valueLineProperties Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getValueLineProperties

          public DrawLine getValueLineProperties()

      Properties for a "value line" - a line shows where a particular discrete value is placed, eg, vertical lines connecting points of a line chart to the X axis, or radial lines in a Radar chart.
      Returns:
        DrawLine

    - #### setValueProperty

          public void setValueProperty(java.lang.String valueProperty)
                                throws java.lang.IllegalStateException

      Property in each record that holds a data value.

      Not used if there is an inline facet, see data.

      Parameters:
        `valueProperty` - . See `String`. Default value is "_value"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getValueProperty

          public java.lang.String getValueProperty()

      Property in each record that holds a data value.

      Not used if there is an inline facet, see data.

      Returns:
        . See `String`

    - #### setValueTitle

          public void setValueTitle(java.lang.String valueTitle)
                             throws java.lang.IllegalStateException

      A label for the data values, such as "Sales in Thousands", typically used as the label for the value axis.
      Parameters:
        `valueTitle` - . See `String`. Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getValueTitle

          public java.lang.String getValueTitle()

      A label for the data values, such as "Sales in Thousands", typically used as the label for the value axis.
      Returns:
        . See `String`

    - #### setXAxisMetric

          public void setXAxisMetric(java.lang.String xAxisMetric)
                              throws java.lang.IllegalStateException

      For scatter charts only, the "id" of the metric facet value to use for the x-axis.

      The default x-axis metric is the second value of the metric facet.

      Parameters:
        `xAxisMetric` - . See `String`. Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getXAxisMetric

          public java.lang.String getXAxisMetric()

      For scatter charts only, the "id" of the metric facet value to use for the x-axis.

      The default x-axis metric is the second value of the metric facet.

      Returns:
        . See `String`

    - #### setYAxisMetric

          public void setYAxisMetric(java.lang.String yAxisMetric)
                              throws java.lang.IllegalStateException

      For scatter charts only, the "id" of the metric facet value to use for the y-axis.

      The default y-axis metric is the first value of the metric facet.

      Parameters:
        `yAxisMetric` - . See `String`. Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getYAxisMetric

          public java.lang.String getYAxisMetric()

      For scatter charts only, the "id" of the metric facet value to use for the y-axis.

      The default y-axis metric is the first value of the metric facet.

      Returns:
        . See `String`

    - #### getZoomChart

          public FacetChart getZoomChart()
                                  throws java.lang.IllegalStateException

      Mini-chart created to allow zooming when `canZoom` is enabled.

      This chart automatically has certain visual tweaks applied, including `showInlineLabels`, `muted colors` and `logarithmic scaling`. It can be further configured via `zoomChartProperties`.

      The selected range from this chart defaults to being shown with distinct styling as well (if `zoomShowSelection` is set), which can be controlled via `zoomSelectionChartProperties`.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        FacetChart
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setZoomChartProperties

          public void setZoomChartProperties(FacetChart zoomChartProperties)
                                      throws java.lang.IllegalStateException

      Properties to further configure the `zoomChart`.
      Parameters:
        `zoomChartProperties` - zoomChartProperties Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getZoomChartProperties

          public FacetChart getZoomChartProperties()

      Properties to further configure the `zoomChart`.
      Returns:
        FacetChart

    - #### getZoomChartSlider

          public RangeSlider getZoomChartSlider()
                                         throws java.lang.IllegalStateException

      Slider controls shown on the mini-chart which is created when `canZoom` is enabled.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        RangeSlider
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setZoomLogScale

          public void setZoomLogScale(java.lang.Boolean zoomLogScale)
                               throws java.lang.IllegalStateException

      By default when `canZoom` is enabled, the `zoomChart` uses logarithmic scaling so that spikes in the data don't result in a zoomed chart that is mostly a flat line.

      Logarithmic scaling is automatically disabled if the dataset spans zero (eg, has negative and positive values) as this can't be shown in a logarithmic scale.

      Set `zoomLogScale` to explicitly enable or disable logarithmic scaling.

      Parameters:
        `zoomLogScale` - zoomLogScale Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getZoomLogScale

          public java.lang.Boolean getZoomLogScale()

      By default when `canZoom` is enabled, the `zoomChart` uses logarithmic scaling so that spikes in the data don't result in a zoomed chart that is mostly a flat line.

      Logarithmic scaling is automatically disabled if the dataset spans zero (eg, has negative and positive values) as this can't be shown in a logarithmic scale.

      Set `zoomLogScale` to explicitly enable or disable logarithmic scaling.

      Returns:
        Boolean

    - #### setZoomMutePercent

          public void setZoomMutePercent(float zoomMutePercent)
                                  throws java.lang.IllegalStateException

      `colorMutePercent` to use for the `zoomChart`.
      Parameters:
        `zoomMutePercent` - zoomMutePercent Default value is -35
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getZoomMutePercent

          public float getZoomMutePercent()

      `colorMutePercent` to use for the `zoomChart`.
      Returns:
        float

    - #### getZoomSelectionChart

          public FacetChart getZoomSelectionChart()
                                           throws java.lang.IllegalStateException

      Mini-chart created when `canZoom` is enabled. This chart represents the currently selected range of data shown in the main chart.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        FacetChart
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setZoomSelectionChartProperties

          public void setZoomSelectionChartProperties(FacetChart zoomSelectionChartProperties)
                                               throws java.lang.IllegalStateException

      Properties to further configure the `zoomSelectionChart`.
      Parameters:
        `zoomSelectionChartProperties` - zoomSelectionChartProperties Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getZoomSelectionChartProperties

          public FacetChart getZoomSelectionChartProperties()

      Properties to further configure the `zoomSelectionChart`.
      Returns:
        FacetChart

    - #### setZoomShowSelection

          public void setZoomShowSelection(java.lang.Boolean zoomShowSelection)
                                    throws java.lang.IllegalStateException

      Whether the selected range should be shown in a different style, which can be configured via `zoomSelectionChartProperties`. This has performance consequences and makes the rendering of the mini-chart slightly slower.
      Parameters:
        `zoomShowSelection` - zoomShowSelection Default value is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getZoomShowSelection

          public java.lang.Boolean getZoomShowSelection()

      Whether the selected range should be shown in a different style, which can be configured via `zoomSelectionChartProperties`. This has performance consequences and makes the rendering of the mini-chart slightly slower.
      Returns:
        Boolean

    - #### setZoomStartPosition

          public void setZoomStartPosition(ZoomStartPosition zoomStartPosition)
                                    throws java.lang.IllegalStateException

      For a `zoomed chart`, determines what portion of the overall dataset should be initially shown in the main chart.

      Default is to show the end of the dataset if the X axis shows time and includes today's date, otherwise to show the start of the dataset.

      Set this property to override this default, or use `zoomStartValue` and `zoomEndValue` to start with a particular range.

      Parameters:
        `zoomStartPosition` - zoomStartPosition Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getZoomStartPosition

          public ZoomStartPosition getZoomStartPosition()

      For a `zoomed chart`, determines what portion of the overall dataset should be initially shown in the main chart.

      Default is to show the end of the dataset if the X axis shows time and includes today's date, otherwise to show the start of the dataset.

      Set this property to override this default, or use `zoomStartValue` and `zoomEndValue` to start with a particular range.

      Returns:
        ZoomStartPosition

    - #### addChartBackgroundDrawnHandler

          public com.google.gwt.event.shared.HandlerRegistration addChartBackgroundDrawnHandler(ChartBackgroundDrawnHandler handler)

      Add a chartBackgroundDrawn handler.

      Called when most elements of the chart other than data data have been drawn, including gradations and legend.

      This notification will be fired each time the chart is redrawn (due to resize, data change, etc). If you want to draw additional information on the chart using `DrawPane` (FacetChart's superclass) and various `DrawItem`s, you should do in response to this notification. Due to auto-sizing, APIs that are typically used to position custom DrawItems (such as `FacetChart.getChartLeft`) may return bad values if called at other times.

      Additional DrawItems added in this method will appear underneath data elements such as bars or columns. See `FacetChart.chartDrawn` for placing DrawItems on top of data elements.

      Specified by:
        `addChartBackgroundDrawnHandler` in interface `HasChartBackgroundDrawnHandlers`
      Parameters:
        `handler` - the chartBackgroundDrawn handler
      Returns:
        `HandlerRegistration` used to remove this handler

    - #### addChartDrawnHandler

          public com.google.gwt.event.shared.HandlerRegistration addChartDrawnHandler(ChartDrawnHandler handler)

      Add a chartDrawn handler.

      Called when all elements of the chart (data lines / shapes, gradations, legend, labels etc) have completed drawing.

      See `FacetChart.chartBackgroundDrawn` for usage information.

      Specified by:
        `addChartDrawnHandler` in interface `HasChartDrawnHandlers`
      Parameters:
        `handler` - the chartDrawn handler
      Returns:
        `HandlerRegistration` used to remove this handler

    - #### getChartCenter

          public Point getChartCenter()

      Returns the centerpoint for radar charts and pie charts.

      Note that unstacked pie charts draw multiple pies, each with their own centers.

      This is only allowed to be called when `FacetChart.chartDrawn` fires.

      Returns:
        the centerpoint for radar charts and pie charts.

    - #### getChartHeight

          public float getChartHeight(boolean recalc)

      Get the height the central chart area, where data elements appear.

      This is only allowed to be called when `FacetChart.chartDrawn` fires.

      Parameters:
        `recalc` - if false then cached value will be returned, otherwise will be recalculated.
      Returns:
        the width of the central chart area.

    - #### getChartHeightAsDouble

          public double getChartHeightAsDouble(boolean recalc)

      Get the height the central chart area, where data elements appear.

      This is only allowed to be called when `FacetChart.chartDrawn` fires.

      Parameters:
        `recalc` - if false then cached value will be returned, otherwise will be recalculated.
      Returns:
        the width of the central chart area.

    - #### getChartLeft

          public float getChartLeft()

      Get the left margin of the central chart area, where data elements appear.

      This is only allowed to be called when `FacetChart.chartDrawn` fires.

      Returns:
        left margin of the central chart area

    - #### getChartLeftAsDouble

          public double getChartLeftAsDouble()

      Get the left margin of the central chart area, where data elements appear.

      This is only allowed to be called when `FacetChart.chartDrawn` fires.

      Returns:
        left margin of the central chart area

    - #### getChartRadius

          public float getChartRadius()

      Returns the radius for radar charts and pie charts. For stacked pie charts this is radius of the outermost pie.

      Note that unstacked pie charts draw multiple pies, each with their own radii.

      This is only allowed to be called when `FacetChart.chartDrawn` fires.

      Returns:
        the radius for radar charts and pie charts.

    - #### getChartRadiusAsDouble

          public double getChartRadiusAsDouble()

      Returns the radius for radar charts and pie charts. For stacked pie charts this is radius of the outermost pie.

      Note that unstacked pie charts draw multiple pies, each with their own radii.

      This is only allowed to be called when `FacetChart.chartDrawn` fires.

      Returns:
        the radius for radar charts and pie charts.

    - #### getChartTop

          public float getChartTop()

      Get the top coordinate of the central chart area, where data elements appear.

      This is only allowed to be called when `FacetChart.chartDrawn` fires.

      Returns:
        The top coordinate of the central chart area

    - #### getChartTopAsDouble

          public double getChartTopAsDouble()

      Get the top coordinate of the central chart area, where data elements appear.

      This is only allowed to be called when `FacetChart.chartDrawn` fires.

      Returns:
        The top coordinate of the central chart area

    - #### getChartWidth

          public float getChartWidth(boolean recalc)

      Get the width of the central chart area, where data elements appear.

      This is only allowed to be called when `FacetChart.chartDrawn` fires.

      Parameters:
        `recalc` - if false then cached value will be returned, otherwise will be recalculated.
      Returns:
        the width of the central chart area.

    - #### getChartWidthAsDouble

          public double getChartWidthAsDouble(boolean recalc)

      Get the width of the central chart area, where data elements appear.

      This is only allowed to be called when `FacetChart.chartDrawn` fires.

      Parameters:
        `recalc` - if false then cached value will be returned, otherwise will be recalculated.
      Returns:
        the width of the central chart area.

    - #### getDataColor

          public java.lang.String getDataColor(int index)

      Get a color from the `dataColors` Array

      Override to provide a dynamic color generation scheme.

      Parameters:
        `index` - index of the visual element to be colored
      Returns:

    - #### getDrawnValue

          public DrawnValue getDrawnValue(FacetValueMap facetValues)

      Returns rendering information for the data value specified by the passed facet values.

      If called before `FacetChart.chartDrawn`, logs a warning and returns null.

      Parameters:
        `facetValues` - facet values of desired data value
      Returns:
        the drawn value, or null for invalid arguments / incorrect timing of call

    - #### getFacet

          public Facet getFacet(java.lang.String facetId)

      Get a facet definition by facetId.
      Parameters:
        `facetId` - the id of the facet to retrieve
      Returns:
        the Facet if found, or null
      See Also:
        `Facet`

    - #### getFacetValue

          public FacetValue getFacetValue(java.lang.String facetId,
                                 java.lang.String facetValueId)

      Get facet value definition by facetId and facetValueId.
      Parameters:
        `facetId` - the id of the facet to retrieve
        `facetValueId` - the id of the facet value to retrieve
      Returns:
        the FacetValue if found, or null
      See Also:
        `FacetValue`

    - #### getGradations

          public float[] getGradations()

      Return an array of the gradation values used in the current chart. Pass these values to `FacetChart.getXCoord` / `FacetChart.getYCoord` (depending on the orientation of the chart) to discover the coordinates where gradations are drawn.

      This is only allowed to be called when `FacetChart.chartDrawn` fires.

      Returns:
        an array of gradation values used in the current chart.

    - #### getNearestDrawnValue

          public DrawnValue getNearestDrawnValue()

      Returns rendering information for the data value that is shown nearest to the passed coordinates, as a `DrawnValue` object.

      Passed X and Y coordinates should be relative to the FacetChart. If neither an X or Y coordinate is passed, both X and Y will use the current `Canvas.getOffsetX` and `Canvas.getOffsetY`.

      If called before `FacetChart.chartDrawn`, logs a warning and returns null. For a chart with multiple vertical axes, returns the nearest point from the first metric only (see `FacetChart overview`). For scatter charts, returns a DrawnValue where the `value` is from the `y-axis metric`.

      Behavior for different chart types is as follows:

      #### Bar / Column

      Returns the centerpoint of the end of the nearest bar or column by considering the Y coordinate (bar) or X coordinate (column) only.

      #### Line / Area

      Returns the nearest point based on which data label is nearest to the passed X coordinate. For multi-series charts, if Y coordinate is not passed the data point returned is from the series that has the highest value at the data label.

      #### Radar

      Returns the data point nearest the passed coordinates by straight line distance. Passing only one coordinate will cause a warning to be logged and null to be returned; passing neither coordinate is allowed (`getOffsetX/Y` will be used).

      #### Pie

      Returns the data point for the segment that would be hit if a line were drawn from the passed coordinates to the center of the pie.

      If there are multiple stacked pies, uses the pie that contains the passed coordinates, otherwise the outermost pie.

      If there are multiple non-stacked pies, uses the pie that is nearest the passed coordinates by straight-line distance to the center of the pie.

      Passing only one coordinate will cause a warning to be logged and null to be returned; passing neither coordinate is allowed (`getOffsetX/Y` will be used).

      If the chart is a `multi-axis chart` then this method takes an optional parameter, `metric`, which causes this method to return a `DrawnValue` from the specified metric. If a metric is not passed then the first metric of the metric facet will be used (or just the `valueProperty` if there is no metric facet).

      Returns:
        the nearest drawn value, or null for invalid arguments / incorrect timing of call

    - #### getNearestDrawnValue

          public DrawnValue getNearestDrawnValue(java.lang.Integer x)

      See Also:
        `FacetChart#getNearestDrawnValue()}`

    - #### getNearestDrawnValue

          public DrawnValue getNearestDrawnValue(java.lang.Integer x,
                                        java.lang.Integer y)

      See Also:
        `FacetChart#getNearestDrawnValue()}`

    - #### getNearestDrawnValue

          public DrawnValue getNearestDrawnValue(java.lang.Integer x,
                                        java.lang.Integer y,
                                        java.lang.String metric)

      Returns rendering information for the data value that is shown nearest to the passed coordinates, as a `DrawnValue` object.

      Passed X and Y coordinates should be relative to the FacetChart. If neither an X or Y coordinate is passed, both X and Y will use the current `Canvas.getOffsetX` and `Canvas.getOffsetY`.

      If called before `FacetChart.chartDrawn`, logs a warning and returns null. For a chart with multiple vertical axes, returns the nearest point from the first metric only (see `FacetChart overview`). For scatter charts, returns a DrawnValue where the `value` is from the `y-axis metric`.

      Behavior for different chart types is as follows:

      #### Bar / Column

      Returns the centerpoint of the end of the nearest bar or column by considering the Y coordinate (bar) or X coordinate (column) only.

      #### Line / Area

      Returns the nearest point based on which data label is nearest to the passed X coordinate. For multi-series charts, if Y coordinate is not passed the data point returned is from the series that has the highest value at the data label.

      #### Radar

      Returns the data point nearest the passed coordinates by straight line distance. Passing only one coordinate will cause a warning to be logged and null to be returned; passing neither coordinate is allowed (`getOffsetX/Y` will be used).

      #### Pie

      Returns the data point for the segment that would be hit if a line were drawn from the passed coordinates to the center of the pie.

      If there are multiple stacked pies, uses the pie that contains the passed coordinates, otherwise the outermost pie.

      If there are multiple non-stacked pies, uses the pie that is nearest the passed coordinates by straight-line distance to the center of the pie.

      Passing only one coordinate will cause a warning to be logged and null to be returned; passing neither coordinate is allowed (`getOffsetX/Y` will be used).

      If the chart is a `multi-axis chart` then this method takes an optional parameter, `metric`, which causes this method to return a `DrawnValue` from the specified metric. If a metric is not passed then the first metric of the metric facet will be used (or just the `valueProperty` if there is no metric facet).

      Parameters:
        `x` - X coordinate
        `y` - Y coordinate
        `metric` - metric over which to determine the drawn value
      Returns:
        the nearest drawn value, or null for invalid arguments / incorrect timing of call

    - #### getNearestDrawnValues

          public DrawnValue[] getNearestDrawnValues()

      Returns an array of `DrawnValue` objects containing rendering information for the data values having each metric that are shown nearest to the passed coordinates.

      Passed X and Y coordinates should be relative to the FacetChart. If neither an X or Y coordinate is passed, both X and Y will use the current `Canvas.getOffsetX` and `Canvas.getOffsetY`.

      The behavior for different chart types is the same as `FacetChart.getNearestDrawnValue`. This method also logs a warning and returns null if called before `FacetChart.chartDrawn`.

      Returns:
        the nearest drawn values for each metric, or null for invalid arguments / incorrect timing of call

    - #### getNearestDrawnValues

          public DrawnValue[] getNearestDrawnValues(java.lang.Integer x)

      See Also:
        `FacetChart#getNearestDrawnValues()}`

    - #### getNearestDrawnValues

          public DrawnValue[] getNearestDrawnValues(java.lang.Integer x,
                                           java.lang.Integer y)

      Returns an array of `DrawnValue` objects containing rendering information for the data values having each metric that are shown nearest to the passed coordinates.

      Passed X and Y coordinates should be relative to the FacetChart. If neither an X or Y coordinate is passed, both X and Y will use the current `Canvas.getOffsetX` and `Canvas.getOffsetY`.

      The behavior for different chart types is the same as `FacetChart.getNearestDrawnValue`. This method also logs a warning and returns null if called before `FacetChart.chartDrawn`.

      Parameters:
        `x` - X coordinate
        `y` - Y coordinate
      Returns:
        the nearest drawn values for each metric, or null for invalid arguments / incorrect timing of call

    - #### getNumDataPoints

          public int getNumDataPoints()

      Count the number of data points.
      Returns:
        the number of data values

    - #### getNumDataPoints

          public int getNumDataPoints(FacetValueMap criteria)

      Count the number of data points.
      Parameters:
        `criteria` - a set of facetValues describing a slice of the data
      Returns:
        the number of data values

    - #### getPolynomialRegressionFunction

          public void getPolynomialRegressionFunction()

      For scatter plots only, get a Function from the specified independent variable X to the specified dependent variable Y that defines the polynomial that best fits the data. See http://en.wikipedia.org/wiki/Polynomial_regression.

    - #### getPolynomialRegressionFunction

          public void getPolynomialRegressionFunction(java.lang.Integer degree)

      See Also:
        `FacetChart#getPolynomialRegressionFunction()}`

    - #### getPolynomialRegressionFunction

          public void getPolynomialRegressionFunction(java.lang.Integer degree,
                                             java.lang.String xMetric)

      See Also:
        `FacetChart#getPolynomialRegressionFunction()}`

    - #### getPolynomialRegressionFunction

          public void getPolynomialRegressionFunction(java.lang.Integer degree,
                                             java.lang.String xMetric,
                                             java.lang.String yMetric)

      For scatter plots only, get a Function from the specified independent variable X to the specified dependent variable Y that defines the polynomial that best fits the data. See http://en.wikipedia.org/wiki/Polynomial_regression.
      Parameters:
        `degree` - the degree of the polynomial. Defaults to `regressionPolynomialDegree`.
        `xMetric` - ID of an inlined facet value to use as the independent variable. Defaults to the `x-axis metric`.
        `yMetric` - ID of an inlined facet value to use as the dependent variable. Defaults to the `y-axis metric`.

    - #### getSimpleLinearRegressionFunction

          public void getSimpleLinearRegressionFunction()

      For scatter plots only, get a Function from the specified independent variable X to the specified dependent variable Y that defines the line that best fits the data. See http://en.wikipedia.org/wiki/Simple_linear_regression.

    - #### getSimpleLinearRegressionFunction

          public void getSimpleLinearRegressionFunction(java.lang.String xMetric)

      See Also:
        `FacetChart#getSimpleLinearRegressionFunction()}`

    - #### getSimpleLinearRegressionFunction

          public void getSimpleLinearRegressionFunction(java.lang.String xMetric,
                                               java.lang.String yMetric)

      For scatter plots only, get a Function from the specified independent variable X to the specified dependent variable Y that defines the line that best fits the data. See http://en.wikipedia.org/wiki/Simple_linear_regression.
      Parameters:
        `xMetric` - ID of an inlined facet value to use as the independent variable. Defaults to the `x-axis metric`.
        `yMetric` - ID of an inlined facet value to use as the dependent variable. Defaults to the `y-axis metric`.

    - #### addZoomChangedHandler

          public com.google.gwt.event.shared.HandlerRegistration addZoomChangedHandler(ZoomChangedHandler handler)

      Add a zoomChanged handler.

      Fires when the end user changes the zoom position in a `zoomed chart`.

      Specified by:
        `addZoomChangedHandler` in interface `HasZoomChangedHandlers`
      Parameters:
        `handler` - the zoomChanged handler
      Returns:
        `HandlerRegistration` used to remove this handler

    - #### zoomTo

          public void zoomTo(java.lang.Object startValue,
                    java.lang.Object endValue)

      For a `zoomed chart`, simultaneously sets the `zoomStartValue` and `zoomEndValue`.
      Parameters:
        `startValue` - starting value for the data range shown in the main chart
        `endValue` - ending value for the data range shown in the main chart

    - #### setDefaultProperties

          public static void setDefaultProperties(FacetChart facetChartProperties)

      Class level method to set the default properties of this class. If set, then all subsequent instances of this class will automatically have the default properties that were set when this method was called. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

      Note: This method is intended for setting default attributes only and will effect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead.

      Parameters:
        `facetChartProperties` - properties that should be used as new defaults when instances of this class are created

    - #### setData

          public void setData(Record[] records)

      Dataset for this chart.

      Data should be specified as an array of Records where each record contains one data value. Each record also contains a property named after each facetId whose value is a facetValueId from that facet.

      For example, with a facet with id "regions" and facetValues "west", "north" and "east", and with `valueProperty` with it's default value "_value", the `data` property could be:

              isc.Chart.create({
                 facets:[{ id:"regions"
           }],
                 data : [
                    {regions:"west", _value:4},
                    {regions:"north", _value:2},

           {regions:"east", _value:5}
                 ]
              })

      If there were a second facet with id "product" and facetValues "cars" and "trucks", a Chart with a complete set of values would be:

           isc.Chart.create({
                 facets:[{ id:"regions" }, { id:"product" }],
                 data : [

           {product:"cars", regions:"west", _value:4},
                    {product:"cars", regions:"north", _value:2},

           {product:"cars", regions:"east", _value:5},
                    {product:"trucks", regions:"west", _value:1},

           {product:"trucks", regions:"north", _value:9},
                    {product:"trucks", regions:"east", _value:3}

           ]
              })

      This 2 facet (or "2 dimensional") dataset, if rendered as a bar chart, would use stacked or clustered bars and a legend.
      Parameters:
        `data` - data Default value is null

    - #### setData

          public void setData(RecordList records)

    - #### getRecords

          public Record[] getRecords()

    - #### getDataAsRecordList

          public RecordList getDataAsRecordList()

    - #### setFacets

          public void setFacets(Facet... facets)

      Set the facets for this chart. These are exactly analgous to `com.smartgwt.client.widgets.cube.CubeGrid#setFacets,CubetGrid facets` except that:
      - the "inlinedValues" property can be set on a facet to change data representation as described under +link{chart.data}.
      - for a non-inlined facet, Charts support auto-derivation of facetValues from the data.
      Parameters:
        `facets` -

    - #### getFacets

          public Facet[] getFacets()

      Return the chart's facets.
      Returns:
        the facets

    - #### setPointHoverCustomizer

          public void setPointHoverCustomizer(ChartPointHoverCustomizer hoverCustomizer)

      Display custom HTML when `showDataPoints` is true and the mouse hovers over a point.
      Parameters:
        `hoverCustomizer` -

    - #### setPointClickHandler

          public void setPointClickHandler(ChartPointClickHandler handler)

      Apply a handler to fire when `showDataPoints` is true, and the user clicks on a point.
      Parameters:
        `handler` -

    - #### getPrintHTML

          public java.lang.String getPrintHTML(PrintProperties printProperties,
                                      PrintHTMLCallback callback)

      Retrieves printable HTML for this component and all printable subcomponents.

      By default any Canvas with children will simply collect the printable HTML of its children by calling getPrintHTML() on each child that is considered `printable`.

      If overriding this method for a custom component, you should either return a String of printable HTML string directly or return null, and fire the callback (if provided).

      To return an empty print representation, return an empty string ("") rather than null.

      The `printProperties` argument, if passed, must be passed to any subcomponents on which `getPrintHTML()` is called.

      Notes on printing

      To print a `FacetChart` for export on IE8 and earlier, it is `PrintProperties` with `printForExport`:true:

           final PrintProperties pp = new PrintProperties();
           pp.setPrintForExport(true);
           final String exportHTML = chart.getPrintHTML(pp, null);

      Note: this is an override point.

      Overrides:
        `getPrintHTML` in class `DrawPane`
      Parameters:
        `printProperties` - properties to configure printing behavior - may be null.
        `callback` - optional callback to fire. Generated HTML should be passed to the `PrintHTMLCallback.setHTML(String)` method of the callback.
      Returns:
        null if the print HTML is being generated asynchronously and/or a callback is provided; otherwise, the direct print HTML for this component (but note that returning direct print HTML is a deprecated feature).
      See Also:
        `Printing overview and related methods`

    - #### setZoomStartValue

          public void setZoomStartValue(java.lang.Object zoomStartValue)

      For a `zoomed chart`, start value of the data range shown in the main chart. If `zoomEndValue` is not also set, the range shown will be from `zoomStartValue` to the end of the dataset.

      The value provided should be a value in the range of the facet for the X axis, for example, for a time-based axis, a Date instance, for a numeric axis, a Number, for an axis that just has text labels (such as city names), a String.
      If this method is called after the component has been drawn/initialized: Setter for `zoomStartValue`.

      Note that the `zoomStartValue` and `zoomEndValue` may be set simultaneously using `FacetChart.zoomTo`.

      Parameters:
        `zoomStartValue` - New start value for the data range shown in the main chart. Default value is null

    - #### getZoomStartValue

          public java.lang.Object getZoomStartValue()

      For a `zoomed chart`, start value of the data range shown in the main chart. If `zoomEndValue` is not also set, the range shown will be from `zoomStartValue` to the end of the dataset.

      The value provided should be a value in the range of the facet for the X axis, for example, for a time-based axis, a Date instance, for a numeric axis, a Number, for an axis that just has text labels (such as city names), a String.

      Returns:
        Object

    - #### setZoomEndValue

          public void setZoomEndValue(java.lang.Object zoomEndValue)

      For a `zoomed chart`, end value of the data range shown in the main chart. If `zoomStartValue` is not also set, the range shown will be from the beginning of the dataset up to `zoomEndValue`

      The value provided should be a value in the range of the facet for the X axis, for example, for a time-based axis, a Date instance, for a numeric axis, a Number, for an axis that just has text labels (such as city names), a String.
      If this method is called after the component has been drawn/initialized: Setter for `zoomEndValue`.

      Note that the `zoomStartValue` and `zoomEndValue` may be set simultaneously using `FacetChart.zoomTo`.

      Parameters:
        `zoomEndValue` - New end value for the data range shown in the main chart. Default value is null

    - #### getZoomEndValue

          public java.lang.Object getZoomEndValue()

      For a `zoomed chart`, end value of the data range shown in the main chart. If `zoomStartValue` is not also set, the range shown will be from the beginning of the dataset up to `zoomEndValue`

      The value provided should be a value in the range of the facet for the X axis, for example, for a time-based axis, a Date instance, for a numeric axis, a Number, for an axis that just has text labels (such as city names), a String.

      Returns:
        Object

    - #### setAxisValueFormatter

          public void setAxisValueFormatter(ValueFormatter formatter)

      Formatter to apply to values displayed in the gradation labels.
      Parameters:
        `formatter` - Formatter to apply to values displayed in the gradation labels

    - #### setXAxisValueFormatter

          public void setXAxisValueFormatter(ValueFormatter formatter)

      Formatter to apply to values displayed in the gradation labels on the x-axis.
      Parameters:
        `formatter` - Formatter to apply to values displayed in the gradation labels

    - #### setYAxisValueFormatter

          public void setYAxisValueFormatter(ValueFormatter formatter)

      Formatter to apply to values displayed in the gradation labels on the y-axis.
      Parameters:
        `formatter` - Formatter to apply to values displayed in the gradation labels

    - #### setDataValueFormatter

          public void setDataValueFormatter(ValueFormatter formatter)

      Formatter to apply to values displayed in the hover labels and other value labels
      Parameters:
        `formatter` - Formatter to apply to values displayed in the hover labels and other value labels

    - #### getXCoord

          public float getXCoord(FacetValueMap criteria)

      Returns the X coordination where the passed data value would be drawn. For example, this would be the X coordinate where a bar would end in a bar chart.

      This is only allowed to be called when `FacetChart.chartDrawn` fires.

      Note that this method is only applicable to `area`, `column`, and `line` charts.

      Parameters:
        `criteria` - A complete mapping of the data facets to specify the unique data cell of the value to be drawn.
      Returns:
        the X coordinate where the passed data value would be drawn.

    - #### getXCoord

          public float getXCoord(float value)

      Returns the X coordination where the passed data value would be drawn. For example, this would be the X coordinate where a bar would end in a bar chart.

      This is only allowed to be called when `FacetChart.chartDrawn` fires.

      Note that this method is only applicable to `bar` and `scatter` charts.

      Parameters:
        `value` - the value to be drawn.
      Returns:
        the X coordinate where the passed data value would be drawn.

    - #### getYCoord

          public float getYCoord(FacetValueMap criteria)

      Returns the Y coordination where the passed data value would be drawn. For example, this would be the X coordinate that a line would pass through on a line chart, or the top of a column on a column chart.

      This is only allowed to be called when `FacetChart.chartDrawn` fires.

      Note that this method is only applicable to `bar` charts.

      Parameters:
        `criteria` - A complete mapping of the data facets to specify the unique data cell of the value to be drawn.
      Returns:
        the Y coordinate where the passed data value would be drawn.

    - #### getYCoord

          public float getYCoord(float value)

      Returns the Y coordination where the passed data value would be drawn. For example, this would be the X coordinate that a line would pass through on a line chart, or the top of a column on a column chart.

      This is only allowed to be called when `FacetChart.chartDrawn` fires.

      Note that this method is only applicable to `area`, `column`, `line`, and `ChartType.SCATTER` charts.

      Parameters:
        `value` - the value to be drawn.
      Returns:
        the Y coordinate where the passed data value would be drawn.

    - #### setStandardDeviations

          public void setStandardDeviations(java.lang.Float[] standardDeviations)
                                     throws java.lang.IllegalStateException

      When `showStandardDeviationLines` is set, the number of standard deviation lines drawn and their respective standard deviation away from the mean are specified by this property. The default is to display lines corresponding to the mean plus or minus one standard deviation.

      Note that having zero in this list of standard deviations is identical to drawing a line at the mean.

      For example assume that chart1 and chart2 below both plot data with mean 1 and standard deviation 0.1. chart1 will draw a blue line at the value 1 and two red lines at the values 0.7 and 1.2. chart2 will draw three red lines at values 0.9, 1.0, and 1.1.

      Parameters:
        `standardDeviations` - standardDeviations Default value is [-1, 1]
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getStandardDeviations

          public java.lang.Float[] getStandardDeviations()

      When `showStandardDeviationLines` is set, the number of standard deviation lines drawn and their respective standard deviation away from the mean are specified by this property. The default is to display lines corresponding to the mean plus or minus one standard deviation.

      Note that having zero in this list of standard deviations is identical to drawing a line at the mean.

      For example assume that chart1 and chart2 below both plot data with mean 1 and standard deviation 0.1. chart1 will draw a blue line at the value 1 and two red lines at the values 0.7 and 1.2. chart2 will draw three red lines at values 0.9, 1.0, and 1.1.

      Returns:
        Float[]

    - #### getMean

          public float getMean(java.lang.String criteria)

      Calculate the mean, or expected value, of the data over a single metric. See http://en.wikipedia.org/wiki/Expected_value.

      The first argument, criteria, determines which metric is used to calculate the mean. The criteria may be a String that is the "id" of some `FacetValue` of the metric facet, or a `FacetValueMap` that contains an entry for the metric facet, or null to use the `valueProperty`. A FacetValueMap criteria may also be used to restrict the calculation to a slice of the data.

      Parameters:
        `criteria` - the "id" of a metric facet value, or a set of mappings describing the data over which to calculate, or null
      Returns:
        the mean of the data values

    - #### getMean

          public float getMean(FacetValueMap criteria)

      Calculate the mean, or expected value, of the data over a single metric. See http://en.wikipedia.org/wiki/Expected_value.

      The first argument, criteria, determines which metric is used to calculate the mean. The criteria may be a String that is the "id" of some `FacetValue` of the metric facet, or a `FacetValueMap` that contains an entry for the metric facet, or null to use the `valueProperty`. A FacetValueMap criteria may also be used to restrict the calculation to a slice of the data.

      Parameters:
        `criteria` - the "id" of a metric facet value, or a set of mappings describing the data over which to calculate, or null
      Returns:
        the mean of the data values

    - #### getMedian

          public float getMedian(java.lang.String criteria)

      Calculate the median of the data over a single metric. See http://en.wikipedia.org/wiki/Median.

      The first argument, criteria, determines which metric is used to calculate the median. The criteria may be a String that is the "id" of some `FacetValue` of the metric facet, or a `FacetValueMap` that contains an entry for the metric facet, or null to use the `valueProperty`. A FacetValueMap criteria may also be used to restrict the calculation to a slice of the data.

      Parameters:
        `criteria` - the "id" of a metric facet value, or a set of mappings describing the data over which to calculate, or null
      Returns:
        the median of the data values

    - #### getMedian

          public float getMedian(FacetValueMap criteria)

      Calculate the median of the data over a single metric. See http://en.wikipedia.org/wiki/Median.

      The first argument, criteria, determines which metric is used to calculate the median. The criteria may be a String that is the "id" of some `FacetValue` of the metric facet, or a `FacetValueMap` that contains an entry for the metric facet, or null to use the `valueProperty`. A FacetValueMap criteria may also be used to restrict the calculation to a slice of the data.

      Parameters:
        `criteria` - the "id" of a metric facet value, or a set of mappings describing the data over which to calculate, or null
      Returns:
        the median of the data values

    - #### getPercentile

          public float getPercentile(java.lang.String criteria,
                            float percentile)

      Calculate a percentile of the data over a single metric. See http://en.wikipedia.org/wiki/Percentile.

      The first argument, criteria, determines which metric is used to calculate a percentile. The criteria may be a String that is the "id" of some `FacetValue` of the metric facet, or a `FacetValueMap` that contains an entry for the metric facet, or null to use the `valueProperty`. A FacetValueMap criteria may also be used to restrict the calculation to a slice of the data.

      The second argument is the percentile to calculate and it must be a number from 0 to 100.

      Parameters:
        `criteria` - the "id" of a metric facet value, or a set of mappings describing the data over which to calculate, or null
        `percentile` - the percentile to calculate
      Returns:
        a percentile of the data values

    - #### getPercentile

          public float getPercentile(FacetValueMap criteria,
                            float percentile)

      Calculate a percentile of the data over a single metric. See http://en.wikipedia.org/wiki/Percentile.

      The first argument, criteria, determines which metric is used to calculate a percentile. The criteria may be a String that is the "id" of some `FacetValue` of the metric facet, or a `FacetValueMap` that contains an entry for the metric facet, or null to use the `valueProperty`. A FacetValueMap criteria may also be used to restrict the calculation to a slice of the data.

      The second argument is the percentile to calculate and it must be a number from 0 to 100.

      Parameters:
        `criteria` - the "id" of a metric facet value, or a set of mappings describing the data over which to calculate, or null
        `percentile` - the percentile to calculate
      Returns:
        a percentile of the data values

    - #### getRange

          public float getRange(java.lang.String criteria)

      Calculate the range of the data from a single metric.

      The first argument, criteria, determines which metric is used to calculate the range. The criteria may be a String that is the "id" of some `FacetValue` of the metric facet, or a `FacetValueMap` that contains an entry for the metric facet, or null to use the `valueProperty`. A FacetValueMap criteria may also be used to restrict the calculation to a slice of the data.

      Parameters:
        `criteria` - the "id" of a metric facet value, or a set of mappings describing the data over which to calculate, or null
      Returns:
        the range of the data values

    - #### getRange

          public float getRange(FacetValueMap criteria)

      Calculate the range of the data from a single metric.

      The first argument, criteria, determines which metric is used to calculate the range. The criteria may be a String that is the "id" of some `FacetValue` of the metric facet, or a `FacetValueMap` that contains an entry for the metric facet, or null to use the `valueProperty`. A FacetValueMap criteria may also be used to restrict the calculation to a slice of the data.

      Parameters:
        `criteria` - the "id" of a metric facet value, or a set of mappings describing the data over which to calculate, or null
      Returns:
        the range of the data values

    - #### getStdDev

          public float getStdDev(java.lang.String criteria,
                        boolean population)

      Calculate the standard deviation of the data from a single metric. See http://en.wikipedia.org/wiki/Standard_deviation.

      The first argument, criteria, determines which metric is used to calculate the standard deviation. The criteria may be a String that is the "id" of some `FacetValue` of the metric facet, or a `FacetValueMap` that contains an entry for the metric facet, or null to use the `valueProperty`. A FacetValueMap criteria may also be used to restrict the calculation to a slice of the data.

      Parameters:
        `criteria` - the "id" of a metric facet value, or a set of mappings describing the data over which to calculate, or null
        `population` - false to calculate a sample standard deviation, true to calculate a population standard deviation
      Returns:
        the standard deviation of the data values

    - #### getStdDev

          public float getStdDev(FacetValueMap criteria,
                        boolean population)

      Calculate the standard deviation of the data from a single metric. See http://en.wikipedia.org/wiki/Standard_deviation.

      The first argument, criteria, determines which metric is used to calculate the standard deviation. The criteria may be a String that is the "id" of some `FacetValue` of the metric facet, or a `FacetValueMap` that contains an entry for the metric facet, or null to use the `valueProperty`. A FacetValueMap criteria may also be used to restrict the calculation to a slice of the data.

      Parameters:
        `criteria` - the "id" of a metric facet value, or a set of mappings describing the data over which to calculate, or null
        `population` - false to calculate a sample standard deviation, true to calculate a population standard deviation
      Returns:
        the standard deviation of the data values

    - #### getVariance

          public float getVariance(java.lang.String criteria,
                          boolean population)

      Calculate the variance of the data from a single metric. See http://en.wikipedia.org/wiki/Variance.

      The first argument, criteria, determines which metric is used to calculate the variance. The criteria may be a String that is the "id" of some `FacetValue` of the metric facet, or a `FacetValueMap` that contains an entry for the metric facet, or null to use the `valueProperty`. A FacetValueMap criteria may also be used to restrict the calculation to a slice of the data.

      Parameters:
        `criteria` - the "id" of a metric facet value, or a set of mappings describing the data over which to calculate, or null
        `population` - false to calculate a sample variance, true to calculate a population variance
      Returns:
        the variance of the data values

    - #### getVariance

          public float getVariance(FacetValueMap criteria,
                          boolean population)

      Calculate the variance of the data from a single metric. See http://en.wikipedia.org/wiki/Variance.

      The first argument, criteria, determines which metric is used to calculate the variance. The criteria may be a String that is the "id" of some `FacetValue` of the metric facet, or a `FacetValueMap` that contains an entry for the metric facet, or null to use the `valueProperty`. A FacetValueMap criteria may also be used to restrict the calculation to a slice of the data.

      Parameters:
        `criteria` - the "id" of a metric facet value, or a set of mappings describing the data over which to calculate, or null
        `population` - false to calculate a sample variance, true to calculate a population variance
      Returns:
        the variance of the data values

    - #### getMax

          public float getMax(java.lang.String criteria)

      Calculate the maximum of the data from a single metric.

      The first argument, criteria, determines which metric is used to calculate the maximum. The criteria may be a String that is the "id" of some `FacetValue` of the metric facet, or a `FacetValueMap` that contains an entry for the metric facet, or null to use the `valueProperty`. A FacetValueMap criteria may also be used to restrict the calculation to a slice of the data.

      Parameters:
        `criteria` - the "id" of a metric facet value, or a set of mappings describing the data over which to calculate, or null
      Returns:
        the maximum of the data values

    - #### getMax

          public float getMax(FacetValueMap criteria)

      Calculate the maximum of the data from a single metric.

      The first argument, criteria, determines which metric is used to calculate the maximum. The criteria may be a String that is the "id" of some `FacetValue` of the metric facet, or a `FacetValueMap` that contains an entry for the metric facet, or null to use the `valueProperty`. A FacetValueMap criteria may also be used to restrict the calculation to a slice of the data.

      Parameters:
        `criteria` - the "id" of a metric facet value, or a set of mappings describing the data over which to calculate, or null
      Returns:
        the maximum of the data values

    - #### getMin

          public float getMin(java.lang.String criteria)

      Calculate the minimum of the data from a single metric.

      The first argument, criteria, determines which metric is used to calculate the minimum. The criteria may be a String that is the "id" of some `FacetValue` of the metric facet, or a `FacetValueMap` that contains an entry for the metric facet, or null to use the `valueProperty`. A FacetValueMap criteria may also be used to restrict the calculation to a slice of the data.

      Parameters:
        `criteria` - the "id" of a metric facet value, or a set of mappings describing the data over which to calculate, or null
      Returns:
        the minimum of the data values

    - #### getMin

          public float getMin(FacetValueMap criteria)

      Calculate the minimum of the data from a single metric.

      The first argument, criteria, determines which metric is used to calculate the minimum. The criteria may be a String that is the "id" of some `FacetValue` of the metric facet, or a `FacetValueMap` that contains an entry for the metric facet, or null to use the `valueProperty`. A FacetValueMap criteria may also be used to restrict the calculation to a slice of the data.

      Parameters:
        `criteria` - the "id" of a metric facet value, or a set of mappings describing the data over which to calculate, or null
      Returns:
        the minimum of the data values

    - #### setLogicalStructure

          public com.smartgwt.logicalstructure.core.LogicalStructureObject setLogicalStructure(com.smartgwt.logicalstructure.widgets.chart.FacetChartLogicalStructure s)

    - #### getLogicalStructure

          public com.smartgwt.logicalstructure.core.LogicalStructureObject getLogicalStructure()

      Specified by:
        `getLogicalStructure` in interface `LogicalStructure`
      Overrides:
        `getLogicalStructure` in class `DrawPane`